<?php

namespace MairieBO\MairieImportBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * Mairie
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="MairieBO\MairieImportBundle\Entity\MairieRepository")
 */
class Mairie
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="reference", type="integer")
     */
    private $reference;

    /**
     * @var string
     *
     * @ORM\Column(name="note", type="string", length=255)
     */
    private $note;

    /**
     * @var string
     *
     * @ORM\Column(name="numero_com", type="string", length=255)
     */
    private $numeroCom;

    /**
     * @var integer
     *
     * @ORM\Column(name="nombre_habitant", type="integer")
     */
    private $nombreHabitant;

    /**
     * @var string
     *
     * @ORM\Column(name="prix_ht", type="decimal", precision=10, scale=2)
     */
    private $prixHt;

    /**
     * @var string
     *
     * @ORM\Column(name="nom_mairie", type="string", length=255)
     */
    private $nomMairie;

    /**
     * @var string
     *
     * @ORM\Column(name="adresse", type="string", length=255)
     */
    private $adresse;

    /**
     * @var string
     *
     * @ORM\Column(name="code_postal", type="string", length=10)
     */
    private $codePostal;

    /**
     * @var string
     *
     * @ORM\Column(name="ville", type="string", length=255)
     */
    private $ville;

    /**
     * @var string
     *
     * @ORM\Column(name="telephone", type="string", length=20)
     */
    private $telephone;

    /**
     * @var string
     *
     * @ORM\Column(name="titre", type="string", length=10)
     */
    private $titre;

    /**
     * @var string
     *
     * @ORM\Column(name="nom_maire", type="string", length=255)
     */
    private $nomMaire;

    /**
     * @var integer
     *
     * @ORM\Column(name="age_maire", type="smallint")
     */
    private $ageMaire;

    /**
     * @var boolean
     *
     * @ORM\Column(name="devis_nom_domaine", type="boolean")
     */
    private $devisNomDomaine;

    /**
     * @var string
     *
     * @ORM\Column(name="nom_domaine_parfait", type="string", length=255)
     */
    private $nomDomaineParfait;

    /**
     * @var string
     *
     * @ORM\Column(name="site_web", type="string", length=255)
     */
    private $siteWeb;

    /**
     * @var string
     *
     * @ORM\Column(name="email", type="string", length=255)
     */
    private $email;

    /**
     * @var boolean
     *
     * @ORM\Column(name="lundi_matin", type="boolean")
     */
    private $lundiMatin;

    /**
     * @var boolean
     *
     * @ORM\Column(name="lundi_apres_midi", type="boolean")
     */
    private $lundiApresMidi;

    /**
     * @var boolean
     *
     * @ORM\Column(name="mardi_matin", type="boolean")
     */
    private $mardiMatin;

    /**
     * @var boolean
     *
     * @ORM\Column(name="mardi_apres_midi", type="boolean")
     */
    private $mardiApresMidi;

    /**
     * @var boolean
     *
     * @ORM\Column(name="mercredi_matin", type="boolean")
     */
    private $mercrediMatin;

    /**
     * @var boolean
     *
     * @ORM\Column(name="mercredi_apres_midi", type="boolean")
     */
    private $mercrediApresMidi;

    /**
     * @var boolean
     *
     * @ORM\Column(name="jeudi_matin", type="boolean")
     */
    private $jeudiMatin;

    /**
     * @var boolean
     *
     * @ORM\Column(name="jeudi_apres_midi", type="boolean")
     */
    private $jeudiApresMidi;

    /**
     * @var boolean
     *
     * @ORM\Column(name="vendredi_matin", type="boolean")
     */
    private $vendrediMatin;

    /**
     * @var boolean
     *
     * @ORM\Column(name="vendredi_apres_midi", type="boolean")
     */
    private $vendrediApresMidi;

    /**
     * @var boolean
     *
     * @ORM\Column(name="samedi_matin", type="boolean")
     */
    private $samediMatin;

    /**
     * @var boolean
     *
     * @ORM\Column(name="samedi_apres_midi", type="boolean")
     */
    private $samediApresMidi;

    /**
     * @var string
     *
     * @ORM\Column(name="heures_ouverture", type="text")
     */
    private $heuresOuverture;

    /**
     * @var string
     *
     * @ORM\Column(name="centres_interets", type="text")
     */
    private $centresInterets;
    
    /**
     * 
     * @ORM\Column(name="date_relance", type="date")
     */
    private $dateRelance;
    /**
     * 
     * @ORM\Column(name="heure_relance", type="decimal", precision=10, scale=2)
     */
    private $heureRelance;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="statut", type="smallint")
     */
    private $statut;
    
    /**
     * @ORM\OneToMany(targetEntity="Note", mappedBy="mairie")
     * @ORM\OrderBy({"dateHeure" = "DESC"})
     **/
    private $notes;
    
    public function __construct()
    {
        $this->notes = new ArrayCollection();
    }
    
    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set reference
     *
     * @param string $reference
     * @return Mairie
     */
    public function setReference($reference)
    {
        $this->reference = $reference;

        return $this;
    }
    
    /**
     * Get reference
     *
     * @return integer 
     */
    public function getReference()
    {
        return $this->reference;
    }

    /**
     * Set note
     *
     * @param string $note
     * @return Mairie
     */
    public function setNote($note)
    {
        $this->note = $note;

        return $this;
    }

    /**
     * Get note
     *
     * @return string 
     */
    public function getNote()
    {
        return $this->note;
    }

    /**
     * Set numeroCom
     *
     * @param string $numeroCom
     * @return Mairie
     */
    public function setNumeroCom($numeroCom)
    {
        $this->numeroCom = $numeroCom;

        return $this;
    }

    /**
     * Get numeroCom
     *
     * @return string 
     */
    public function getNumeroCom()
    {
        return $this->numeroCom;
    }

    /**
     * Set nombreHabitant
     *
     * @param integer $nombreHabitant
     * @return Mairie
     */
    public function setNombreHabitant($nombreHabitant)
    {
        $this->nombreHabitant = $nombreHabitant;

        return $this;
    }

    /**
     * Get nombreHabitant
     *
     * @return integer 
     */
    public function getNombreHabitant()
    {
        return $this->nombreHabitant;
    }

    /**
     * Set prixHt
     *
     * @param string $prixHt
     * @return Mairie
     */
    public function setPrixHt($prixHt)
    {
        $this->prixHt = $prixHt;

        return $this;
    }

    /**
     * Get prixHt
     *
     * @return string 
     */
    public function getPrixHt()
    {
        return $this->prixHt;
    }

    /**
     * Set nomMairie
     *
     * @param string $nomMairie
     * @return Mairie
     */
    public function setNomMairie($nomMairie)
    {
        $this->nomMairie = $nomMairie;

        return $this;
    }

    /**
     * Get nomMairie
     *
     * @return string 
     */
    public function getNomMairie()
    {
        return $this->nomMairie;
    }

    /**
     * Set adresse
     *
     * @param string $adresse
     * @return Mairie
     */
    public function setAdresse($adresse)
    {
        $this->adresse = $adresse;

        return $this;
    }

    /**
     * Get adresse
     *
     * @return string 
     */
    public function getAdresse()
    {
        return $this->adresse;
    }

    /**
     * Set codePostal
     *
     * @param string $codePostal
     * @return Mairie
     */
    public function setCodePostal($codePostal)
    {
        $this->codePostal = $codePostal;

        return $this;
    }

    /**
     * Get codePostal
     *
     * @return string 
     */
    public function getCodePostal()
    {
        return $this->codePostal;
    }

    /**
     * Set ville
     *
     * @param string $ville
     * @return Mairie
     */
    public function setVille($ville)
    {
        $this->ville = $ville;

        return $this;
    }

    /**
     * Get ville
     *
     * @return string 
     */
    public function getVille()
    {
        return $this->ville;
    }

    /**
     * Set telephone
     *
     * @param string $telephone
     * @return Mairie
     */
    public function setTelephone($telephone)
    {
        $this->telephone = $telephone;

        return $this;
    }

    /**
     * Get telephone
     *
     * @return string 
     */
    public function getTelephone()
    {
        return $this->telephone;
    }

    /**
     * Set titre
     *
     * @param string $titre
     * @return Mairie
     */
    public function setTitre($titre)
    {
        $this->titre = $titre;

        return $this;
    }

    /**
     * Get titre
     *
     * @return string 
     */
    public function getTitre()
    {
        return $this->titre;
    }

    /**
     * Set nomMaire
     *
     * @param string $nomMaire
     * @return Mairie
     */
    public function setNomMaire($nomMaire)
    {
        $this->nomMaire = $nomMaire;

        return $this;
    }

    /**
     * Get nomMaire
     *
     * @return string 
     */
    public function getNomMaire()
    {
        return $this->nomMaire;
    }

    /**
     * Set ageMaire
     *
     * @param integer $ageMaire
     * @return Mairie
     */
    public function setAgeMaire($ageMaire)
    {
        $this->ageMaire = $ageMaire;

        return $this;
    }

    /**
     * Get ageMaire
     *
     * @return integer 
     */
    public function getAgeMaire()
    {
        return $this->ageMaire;
    }

    /**
     * Set devisNomDomaine
     *
     * @param boolean $devisNomDomaine
     * @return Mairie
     */
    public function setDevisNomDomaine($devisNomDomaine)
    {
        $this->devisNomDomaine = $devisNomDomaine;

        return $this;
    }

    /**
     * Get devisNomDomaine
     *
     * @return boolean 
     */
    public function getDevisNomDomaine()
    {
        return $this->devisNomDomaine;
    }

    /**
     * Set nomDomaineParfait
     *
     * @param string $nomDomaineParfait
     * @return Mairie
     */
    public function setNomDomaineParfait($nomDomaineParfait)
    {
        $this->nomDomaineParfait = $nomDomaineParfait;

        return $this;
    }

    /**
     * Get nomDomaineParfait
     *
     * @return string 
     */
    public function getNomDomaineParfait()
    {
        return $this->nomDomaineParfait;
    }

    /**
     * Set siteWeb
     *
     * @param string $siteWeb
     * @return Mairie
     */
    public function setSiteWeb($siteWeb)
    {
        $this->siteWeb = $siteWeb;

        return $this;
    }

    /**
     * Get siteWeb
     *
     * @return string 
     */
    public function getSiteWeb()
    {
        return $this->siteWeb;
    }

    /**
     * Set email
     *
     * @param string $email
     * @return Mairie
     */
    public function setEmail($email)
    {
        $this->email = $email;

        return $this;
    }

    /**
     * Get email
     *
     * @return string 
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set lundiMatin
     *
     * @param boolean $lundiMatin
     * @return Mairie
     */
    public function setLundiMatin($lundiMatin)
    {
        $this->lundiMatin = $lundiMatin;

        return $this;
    }

    /**
     * Get lundiMatin
     *
     * @return boolean 
     */
    public function getLundiMatin()
    {
        return $this->lundiMatin;
    }

    /**
     * Set lundiApresMidi
     *
     * @param boolean $lundiApresMidi
     * @return Mairie
     */
    public function setLundiApresMidi($lundiApresMidi)
    {
        $this->lundiApresMidi = $lundiApresMidi;

        return $this;
    }

    /**
     * Get lundiApresMidi
     *
     * @return boolean 
     */
    public function getLundiApresMidi()
    {
        return $this->lundiApresMidi;
    }

    /**
     * Set mardiMatin
     *
     * @param boolean $mardiMatin
     * @return Mairie
     */
    public function setMardiMatin($mardiMatin)
    {
        $this->mardiMatin = $mardiMatin;

        return $this;
    }

    /**
     * Get mardiMatin
     *
     * @return boolean 
     */
    public function getMardiMatin()
    {
        return $this->mardiMatin;
    }

    /**
     * Set mardiApresMidi
     *
     * @param boolean $mardiApresMidi
     * @return Mairie
     */
    public function setMardiApresMidi($mardiApresMidi)
    {
        $this->mardiApresMidi = $mardiApresMidi;

        return $this;
    }

    /**
     * Get mardiApresMidi
     *
     * @return boolean 
     */
    public function getMardiApresMidi()
    {
        return $this->mardiApresMidi;
    }

    /**
     * Set mercrediMatin
     *
     * @param boolean $mercrediMatin
     * @return Mairie
     */
    public function setMercrediMatin($mercrediMatin)
    {
        $this->mercrediMatin = $mercrediMatin;

        return $this;
    }

    /**
     * Get mercrediMatin
     *
     * @return boolean 
     */
    public function getMercrediMatin()
    {
        return $this->mercrediMatin;
    }

    /**
     * Set mercrediApresMidi
     *
     * @param boolean $mercrediApresMidi
     * @return Mairie
     */
    public function setMercrediApresMidi($mercrediApresMidi)
    {
        $this->mercrediApresMidi = $mercrediApresMidi;

        return $this;
    }

    /**
     * Get mercrediApresMidi
     *
     * @return boolean 
     */
    public function getMercrediApresMidi()
    {
        return $this->mercrediApresMidi;
    }

    /**
     * Set jeudiMatin
     *
     * @param boolean $jeudiMatin
     * @return Mairie
     */
    public function setJeudiMatin($jeudiMatin)
    {
        $this->jeudiMatin = $jeudiMatin;

        return $this;
    }

    /**
     * Get jeudiMatin
     *
     * @return boolean 
     */
    public function getJeudiMatin()
    {
        return $this->jeudiMatin;
    }

    /**
     * Set jeudiApresMidi
     *
     * @param boolean $jeudiApresMidi
     * @return Mairie
     */
    public function setJeudiApresMidi($jeudiApresMidi)
    {
        $this->jeudiApresMidi = $jeudiApresMidi;

        return $this;
    }

    /**
     * Get jeudiApresMidi
     *
     * @return boolean 
     */
    public function getJeudiApresMidi()
    {
        return $this->jeudiApresMidi;
    }

    /**
     * Set vendrediMatin
     *
     * @param boolean $vendrediMatin
     * @return Mairie
     */
    public function setVendrediMatin($vendrediMatin)
    {
        $this->vendrediMatin = $vendrediMatin;

        return $this;
    }

    /**
     * Get vendrediMatin
     *
     * @return boolean 
     */
    public function getVendrediMatin()
    {
        return $this->vendrediMatin;
    }

    /**
     * Set vendrediApresMidi
     *
     * @param boolean $vendrediApresMidi
     * @return Mairie
     */
    public function setVendrediApresMidi($vendrediApresMidi)
    {
        $this->vendrediApresMidi = $vendrediApresMidi;

        return $this;
    }

    /**
     * Get vendrediApresMidi
     *
     * @return boolean 
     */
    public function getVendrediApresMidi()
    {
        return $this->vendrediApresMidi;
    }

    /**
     * Set samediMatin
     *
     * @param boolean $samediMatin
     * @return Mairie
     */
    public function setSamediMatin($samediMatin)
    {
        $this->samediMatin = $samediMatin;

        return $this;
    }

    /**
     * Get samediMatin
     *
     * @return boolean 
     */
    public function getSamediMatin()
    {
        return $this->samediMatin;
    }

    /**
     * Set samediApresMidi
     *
     * @param boolean $samediApresMidi
     * @return Mairie
     */
    public function setSamediApresMidi($samediApresMidi)
    {
        $this->samediApresMidi = $samediApresMidi;

        return $this;
    }

    /**
     * Get samediApresMidi
     *
     * @return boolean 
     */
    public function getSamediApresMidi()
    {
        return $this->samediApresMidi;
    }

    /**
     * Set heuresOuverture
     *
     * @param string $heuresOuverture
     * @return Mairie
     */
    public function setHeuresOuverture($heuresOuverture)
    {
        $this->heuresOuverture = $heuresOuverture;

        return $this;
    }

    /**
     * Get heuresOuverture
     *
     * @return string 
     */
    public function getHeuresOuverture()
    {
        return $this->heuresOuverture;
    }

    /**
     * Set centresInterets
     *
     * @param string $centresInterets
     * @return Mairie
     */
    public function setCentresInterets($centresInterets)
    {
        $this->centresInterets = $centresInterets;

        return $this;
    }

    /**
     * Get centresInterets
     *
     * @return string 
     */
    public function getCentresInterets()
    {
        return $this->centresInterets;
    }
    
    public function setDateRelance($dateRelance)
    {
	$this->dateRelance = $dateRelance;
	    
	return $this;
    }
    
    public function getDateRelance()
    {
	return $this->dateRelance;
    }
    
    public function setHeureRelance($heureRelance)
    {
	$this->heureRelance = $heureRelance;
	    
	return $this;
    }
    
    public function getHeureRelance()
    {
	return $this->heureRelance;
    }
    
    public function setStatut($statut)
    {
	$this->statut = $statut;
	    
	return $this;
    }
    
    public function getStatut()
    {
	return $this->statut;
    }
    
    public function getNotes()
    {
	return $this->notes;
    }
}
