<?php

namespace MairieBO\MairieImportBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class MairieType extends AbstractType
{
    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
	$years = array();
	
	for ($i=date("Y"); $i<date("Y")+3; $i++) {
		$years[] = $i;
	}
	
        $builder
            ->add('note', 'textarea', array('required' => false))
            ->add('numeroCom')
            ->add('nombreHabitant')
            ->add('prixHt')
            ->add('nomMairie')
            ->add('adresse')
            ->add('codePostal')
            ->add('ville')
            ->add('telephone')
            ->add('titre')
            ->add('nomMaire', 'text', array('required' => false))
            ->add('ageMaire', 'text', array('required' => false))
            ->add('devisNomDomaine', 'checkbox', array('required' => false))
            ->add('nomDomaineParfait', 'text', array('required' => false))
            ->add('siteWeb', 'text', array('required' => false))
            ->add('email')
            ->add('lundiMatin', 'checkbox', array('required' => false))
            ->add('lundiApresMidi', 'checkbox', array('required' => false))
            ->add('mardiMatin', 'checkbox', array('required' => false))
            ->add('mardiApresMidi', 'checkbox', array('required' => false))
            ->add('mercrediMatin', 'checkbox', array('required' => false))
            ->add('mercrediApresMidi', 'checkbox', array('required' => false))
            ->add('jeudiMatin', 'checkbox', array('required' => false))
            ->add('jeudiApresMidi', 'checkbox', array('required' => false))
            ->add('vendrediMatin', 'checkbox', array('required' => false))
            ->add('vendrediApresMidi', 'checkbox', array('required' => false))
            ->add('samediMatin', 'checkbox', array('required' => false))
            ->add('samediApresMidi', 'checkbox', array('required' => false))
            ->add('heuresOuverture', 'textarea', array('required' => false))
            ->add('centresInterets', 'textarea', array('required' => false))
	    ->add('statut', 'choice', array(
		'choices'   => array(0 => 'Non contacté', 1 => 'En cours', 2 => 'Devis envoyé', 3 => 'A relancer', 4 => 'Perdu', 5 => 'Gagné'),
		'required'  => true
	    ))
	    ->add('dateRelance', 'date', array(
		'required' => false,
		'years' => $years,
		'format' => 'dd/MM/yyyy'
	    ))
	    ->add('heureRelance', 'choice', array(
		'choices' => \MairieBO\MairieImportBundle\Util\HeureRelance::texte2heure()
	    ))
        ;
    }
    
    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'MairieBO\MairieImportBundle\Entity\Mairie'
        ));
    }

    /**
     * @return string
     */
    public function getName()
    {
        return 'mairiebo_mairieimportbundle_mairie';
    }
}
