<?php

namespace MairieGestion\FrontBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Response;

use MairieGestion\FrontBundle\Form\ContactType;

class DefaultController extends Controller
{
    /**
     * @Route("/", name="home")
     * @Template()
     */
    public function indexAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        $events = $em->getRepository('MairieGestionPlanningBundle:Event')->getEventsHome($mairie);
        $agendaPage = $em->getRepository('MairieGestionPageBundle:Page')->getAgendaPage($mairie);
        $configsReseauxSociaux = $em->getRepository('MairieGestionPageBundle:Config')->getReseauxSociauxConfigsByMairie($mairie);
	
	return array(
            'mairie' => $mairie,
            'events' => $events,
            'agendaPage' => $agendaPage,
	    'configsReseauxSociaux' => $configsReseauxSociaux
        );
    }
    
    /**
     * @Route("/mentions-legales", name="mentions_legales")
     * @Template()
     */
    public function mentionsLegalesAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        return array(
            'mairie' => $mairie,
        );
    }
    
    /**
     * @Route("/{path}", name="page", requirements={"path" = ".+"})
     * @Template()
     */
    public function pageAction($path)
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        $page = $em->getRepository('MairieGestionPageBundle:Page')->getPageByPath($mairie,$path);
        $page = $page?$page[0]:null;
        $message_send = false;
        if (!$page)
        {
            // throw $this->createNotFoundException('', array( 'mairie' => $mairie,));
            // return $this->redirect($this->generateUrl('not_found'), 404);
            $response = $this->render('MairieGestionFrontBundle:Default:notFound.html.twig', array(
                'mairie' => $mairie,
            ));
            $response->setStatusCode(404);    
            return $response;
        }
        
        if ($page->getType()->getId() == 4)
        {
            $form = $this->get('form.factory')->create(new ContactType());
            $request = $this->getRequest();
            if ($request->getMethod() == 'POST') {
                $form->handleRequest($request);
                $content = 'Nom : '.$form->get('name')->getData().'<br />';
                $content .= 'Prénom : '.$form->get('first_name')->getData().'<br />';
                $content .= 'Email : '.$form->get('email')->getData().'<br />';
                $content .= 'Téléphone : '.$form->get('tel')->getData().'<br />';
                $content .= 'Sujet : '.$form->get('subject')->getData().'<br /><br />';
                $content .= 'Message : '.'<br /><br />'.$form->get('content')->getData().'<br />';
                if ($form->isValid()) {
                    $message = \Swift_Message::newInstance()
                        ->setSubject('Mail de contact : '.$form->get('subject')->getData())
                        ->setFrom($mairie->getEmail())
                        ->addReplyTo($form->get('email')->getData())
                        ->setTo($mairie->getEmail())
                        ->setContentType('text/html')
                        // ->setBody($content)
                        ->setBody($this->container->get('templating')->render('MairieGestionFrontBundle:Default:emailContact.email.twig',
		    				array(
                                'content' => nl2br($form->get('content')->getData()),
                                'form' => $form->createView(),
                                'mairie' => $mairie,
                                'base_url' => str_replace('/app_dev.php','',$base_url),
                            )))
                        ;
                    ;
            
                    $this->get('mailer')->send($message);
                    $message_send = true;
                    $form = $this->get('form.factory')->create(new ContactType());
                }
            }
            
            return $this->render('MairieGestionFrontBundle:Default:pageContact.html.twig', array(
                'form' => $form->createView(),
                'page' => $page,
                'mairie' => $mairie,
                'message_send' => $message_send,
            ));
        }
        $membres = array();
        $adjoints = array();
        $conseillers = array();
        if ($page->getType()->getId() == 7)
        {
            $membres = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($mairie->getConseilCourant());
            $adjoints = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($mairie->getConseilCourant(),2);
            $conseillers = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($mairie->getConseilCourant(),3);
	    return $this->pageConseilsMunicipaux($mairie, $page, $membres, $adjoints, $conseillers);
        }
        if ($page->getType()->getId() == 8)
            return $this->pageHistoriqueConseil($mairie,$page,$em);
        if ($page->getType()->getId() == 9)
            return $this->pagePlu($mairie,$page,$em);
        if ($page->getType()->getId() == 10)
            return $this->pageAgenda($mairie,$page,$em);
        if ($page->getType()->getId() == 11)
            return $this->pagePdf($mairie,$page,$em);
	if ($page->getType()->getId() == 1)
            return $this->pageDiaporama($mairie, $page);
	if ($page->getType()->getId() == 2)
            return $this->pageCarte($mairie, $page);
	
        $archives = array();
        
	if ($page->getType()->getId() == 5) {
            $archives = $em->getRepository('MairieGestionPageBundle:Archive')->getBulletinsMunicipaux($mairie);
	
	    return $this->pageBulletinMunicipal($mairie, $page, $archives);
	}
	
        if ($page->getType()->getId() == 6) {
            $archives = $em->getRepository('MairieGestionPageBundle:Archive')->getComptesRendus($mairie);
	
	    return $this->pageComptesRendusDuConseil($mairie, $page, $archives);
	}
	
	return $this->render(
    'MairieGestionFrontBundle:Default:page.html.twig',
    array(
            'conseillers' => $conseillers,
            'adjoints' => $adjoints,
            'archives' => $archives,
            'page' => $page,
            'mairie' => $mairie,
            'message_send' => $message_send,
            'membres' => $membres,
        ));
    }
    
    public function pageConseilsMunicipaux($mairie, $page, $membres, $adjoints, $conseillers)
    {
        return $this->render('MairieGestionFrontBundle:Default:pageConseilsMunicipaux.html.twig', array(
	    'mairie' => $mairie,
	    'page' => $page,
	    'membres' => $membres,
	    'adjoints' => $adjoints,
	    'conseillers' => $conseillers
	));
    }
    
    public function pageCarte($mairie, $page)
    {
	return $this->render('MairieGestionFrontBundle:Default:pageCarte.html.twig', array(
	    'mairie' => $mairie,
            'page' => $page
        ));  
    }
    
    public function pageBulletinMunicipal($mairie, $page, $archives)
    {
	return $this->render('MairieGestionFrontBundle:Default:pageBulletinMunicipal.html.twig', array(
	    'mairie' => $mairie,
            'page' => $page,
            'archives' => $archives
        ));  
    }
    
    public function pageComptesRendusDuConseil($mairie, $page, $archives)
    {
	return $this->render('MairieGestionFrontBundle:Default:pageComptesRendusDuConseil.html.twig', array(
	    'mairie' => $mairie,
            'page' => $page,
            'archives' => $archives
        ));  
    }
    
    public function pageDiaporama($mairie, $page)
    {
	return $this->render('MairieGestionFrontBundle:Default:pageDiaporama.html.twig', array(
	    'mairie' => $mairie,
            'page' => $page
        ));  
    }
    
    /**
     * @Template()
     */
    public function pageHistoriqueConseil($mairie, $page, $em)
    {
        $conseils = $em->getRepository('MairieGestionPageBundle:Conseil')->getConseilsFront($mairie);
        $photos = array();
        $membres = array();
        $adjoints = array();
        $conseillers = array();
        if ($page->getType()->getId() == 7)
        {
            $membres = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($mairie->getConseilCourant());
            $adjoints = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($mairie->getConseilCourant(),2);
            $conseillers = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($mairie->getConseilCourant(),3);
        }
        
        foreach($conseils as $conseil)
        {
	    if ($conseil->getPhoto()) {
		$photos[] = $conseil->getPhoto();
	    }
		
            $membres[$conseil->getId()] = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($conseil);
            $adjoints[$conseil->getId()] = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($conseil,2);
            $conseillers[$conseil->getId()] = $em->getRepository('MairieGestionPageBundle:ConseilMembre')->getMembresFront($conseil,3);
        }
        return $this->render('MairieGestionFrontBundle:Default:pageHistoriqueConseil.html.twig', array(
            'membres' => $membres,
            'adjoints' => $adjoints,
            'conseillers' => $conseillers,
            'photos' => $photos,
            'conseils' => $conseils,
            'page' => $page,
            'mairie' => $mairie,
        ));
    }
    
    /**
     * @Template()
     */
    public function pageAgenda($mairie, $page, $em)
    {
        $events = $em->getRepository('MairieGestionPlanningBundle:Event')->getEventsFront($mairie);
        return $this->render('MairieGestionFrontBundle:Default:pageAgenda.html.twig', array(
            'events' => $events,
            'page' => $page,
            'mairie' => $mairie,
        ));
    }
    
    /**
     * @Template()
     */
    public function pagePdf($mairie, $page, $em)
    {
        $events = $em->getRepository('MairieGestionPlanningBundle:Event')->getEventsFront($mairie);
        return $this->render('MairieGestionFrontBundle:Default:pagePdf.html.twig', array(
            'events' => $events,
            'page' => $page,
            'mairie' => $mairie,
        ));
    }
    
    /**
     * @Template()
     */
    public function pagePlu($mairie, $page, $em)
    {
        $plu = $em->getRepository('MairieGestionPageBundle:Plu')->find($page->getPlu()->getId());
        return $this->render('MairieGestionFrontBundle:Default:pagePlu.html.twig', array(
            'plu' => $plu,
            'page' => $page,
            'mairie' => $mairie,
        ));
    }
    
    /**
     * @Template()
     */
    public function menuAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        $pages = $em->getRepository('MairieGestionPageBundle:Page')->getPagesFirstLevel($mairie);
        return array(
            'mairie' => $mairie,
            'pages' => $pages,
        );
    }
    
    /**
     * @Template()
     */
    public function logoAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        return new Response($mairie->getName());
    }
    
    /**
     * @Template()
     */
    public function mairieNameAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        return new Response($mairie->getName());
    }
    
    /**
     * @Template()
     */
    public function mairieMetaTitleAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        return new Response($mairie->getMetaTitle()?$mairie->getMetaTitle():$mairie->getName());
    }
    
    /**
     * @Template()
     */
    public function mairieGoogleAnalyticsAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        return new Response($mairie->getGoogleAnalytics());
    }
    
    /**
     * @Template()
     */
    public function mairieGoogleVerificationAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        return array('mairie'=>$mairie);
    }
    
    /**
     * @Template()
     */
    public function imgHeaderAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
        return array('mairie' => $mairie);
    }
    
    /**
     * @Template()
     */
    public function imgHeaderResponsiveAction()
    {
        $em = $this->getDoctrine()->getManager();
        $base_url = $this->getRequest()->getUriForPath('');
        $mairie = $em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByDomaine($base_url);
	
        return array(
	    'mairie' => $mairie
	);
    }
}
