<?php
namespace MairieGestion\FrontBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Validator\Constraints\NotBlank;
use Symfony\Component\Validator\Constraints\Email;
use Symfony\Component\Validator\Constraints\Length;

class ContactType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
    	$builder
            ->add('first_name', 'text', array(
                'label' => 'Prénom',
                'attr' => array('placeholder'=>'Votre prénom','class'=>'form-control'),
                'constraints' => array(new NotBlank(array(
                                    'message' => 'Veuillez saisir votre prénom',
                            ))),
            ))
            ->add('name', 'text', array(
                'label' => 'Nom',
                'attr' => array('placeholder'=>'Votre nom','class'=>'form-control'),
                'constraints' => array(new NotBlank(array(
                                    'message' => 'Veuillez saisir votre nom',
                            ))),
            ))
            ->add('email', 'email', array(
                'label' => 'Adresse email',	
                'attr' => array('placeholder'=>'Votre adresse email','class'=>'form-control'),
                'constraints' => array(new NotBlank(array(
                                    'message' => 'Veuillez saisir votre adresse email',
                            )), new Email()),
            ))
            ->add('tel', 'text', array(
                'label' => 'Numéro de téléphone',
                'attr' => array('placeholder'=>'Votre numéro de téléphone','class'=>'form-control'),	
                'constraints' => array(new NotBlank(array(
                                    'message' => 'Veuillez saisir votre numéro de téléphone',
                            ))),
            ))
            ->add('subject', 'text', array(
                'label' => 'Sujet',
                'attr' => array('placeholder'=>'Votre sujet','class'=>'form-control'),	
                'constraints' => new NotBlank(array(
                                    'message' => 'Veuillez saisir le sujet du message',
                            )),
            ))
            ->add('content', 'textarea', array(
                'constraints' => array(new NotBlank(array(
                                    'message' => 'Veuillez saisir votre message',
                            ))),
                'label' => 'Message',
                'attr' => array('style' => 'height:200px','placeholder'=>'Votre message','class'=>'form-control'),	
            ))
            ->add('submit', 'submit', array(
                    'attr'=> array('class'=>'btn btn-primary btn-block', 'formnovalidate'=>true),
                    'label' => 'Envoyer',
            ))
        ;
    }
    
    public function getName()
    {
    	return 'contact';
    }
}