<?php

namespace MairieGestion\MainBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use MairieGestion\MainBundle\Helper\Utils;

class DefaultController extends Controller
{
    /**
     * @Route("/menu", name="sous_menu")
     * @Template()
     */
    public function sousMenuAction($route)
    {
        $categorie = explode('_',$route)[0];
        $securityContext = $this->container->get('security.context');
        $request = Request::createFromGlobals();
        $route_courante = 'tarifs_liste';
        $request = $this->container->get('request');
        $sous_menu = array();
        $titre = 'Menu';
        if($categorie == 'user')
        {
            $titre = 'Personnel';
            $sous_menu = array(
                'user_liste'=>'Liste du personnel',
                'user_new'=>'Nouveau personnel',
            );
        }
        elseif($categorie == 'page')
        {
            $titre = 'Page';
            $sous_menu = array(
                'page_arborescence'=>'Arborescence',
                'page_new'=>'Nouvelle page',
            );
        }
        elseif($categorie == 'carte')
        {
            $titre = 'Carte';
            $sous_menu = array(
                'carte_liste'=>'Cartes Google',
                'carte_plu_liste'=>'P.L.U',
                'carte_archive'=>'Archives',
            );
        }
        elseif($categorie == 'photo')
        {
            $titre = 'Photo';
            $sous_menu = array(
                'photo_albums'=>'Albums',
                'photo_album_photo'=>'Photo d\'album',
                'photo_url'=>'Images URL',
                'photo_archive'=>'Images archivées PAGE D`ACCUEIL',
            );
        }
        elseif($categorie == 'archive')
        {
            $titre = 'Archive';
            $sous_menu = array(
                'archive_liste_bulletins_municipaux'=>'Bulletins municipaux',
                'archive_liste_comptes_rendus'=>'Comptes-rendus des conseils',
            );
        }
        elseif($categorie == 'conseil')
        {
            $titre = 'Conseils municipaux';
            $sous_menu = array(
                'conseil_liste'=>'Liste des conseils',
                'conseil_new'=>'Nouveau conseil',
            );
        }
        elseif($categorie == 'planning')
        {
            $titre = 'Agenda';
            $sous_menu = array(
                'planning_liste' => 'Evénement',
                'planning_new' => 'Nouvel événement',
            );
        }
        elseif($categorie == 'param')
        {
            $titre = 'Paramètre';
            $sous_menu = array(
                'param_generale' => 'Informations générales',
                'param_reseaux_sociaux' => 'Réseaux sociaux',
                'param_restriction' => 'Restrictions',
                'param_referencement' => 'Référencement',
                'param_avance' => 'Avancés',
                'param_user_liste' => 'Personnel',
                'param_apparence' => 'Apparence',
            );
        }
        return array('route_courant'=>$route,'sous_menu'=>$sous_menu,'titre'=>$titre);
    }
}
