<?php

namespace MairieGestion\MainBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Civilite
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="MairieGestion\MainBundle\Entity\CiviliteRepository")
 */
class Civilite
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=255)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="short_name", type="string", length=255)
     */
    private $shortName;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="feminin", type="boolean")
     */
    private $feminin;

    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\ConseilMembre", mappedBy="civilite", cascade={"persist", "remove"})
     * @ORM\OrderBy({"position" = "ASC"})
     */
    private $membres;
    
    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return Civilite
     */
    public function setName($name)
    {
        $this->name = $name;
    
        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set feminin
     *
     * @param boolean $feminin
     * @return Civilite
     */
    public function setFeminin($feminin)
    {
        $this->feminin = $feminin;
    
        return $this;
    }

    /**
     * Get feminin
     *
     * @return boolean 
     */
    public function getFeminin()
    {
        return $this->feminin;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->membres = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add membres
     *
     * @param \MairieGestion\PageBundle\Entity\ConseilMembre $membres
     * @return Civilite
     */
    public function addMembre(\MairieGestion\PageBundle\Entity\ConseilMembre $membres)
    {
        $this->membres[] = $membres;
    
        return $this;
    }

    /**
     * Remove membres
     *
     * @param \MairieGestion\PageBundle\Entity\ConseilMembre $membres
     */
    public function removeMembre(\MairieGestion\PageBundle\Entity\ConseilMembre $membres)
    {
        $this->membres->removeElement($membres);
    }

    /**
     * Get membres
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getMembres()
    {
        return $this->membres;
    }

    /**
     * Set shortName
     *
     * @param string $shortName
     * @return Civilite
     */
    public function setShortName($shortName)
    {
        $this->shortName = $shortName;
    
        return $this;
    }

    /**
     * Get shortName
     *
     * @return string 
     */
    public function getShortName()
    {
        return $this->shortName;
    }
}