<?php

namespace MairieGestion\MainBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\HttpFoundation\File\UploadedFile;

 
/**
 * MairieGestion\MainBundle\Entity\Photos
 *
 * @ORM\Entity
 * @ORM\Table(name="Photos", indexes={@ORM\Index(name="search_idx", columns={"title"})}))
 * @ORM\Entity(repositoryClass="MairieGestion\MainBundle\Entity\PhotosRepository")
 * @ORM\HasLifecycleCallbacks()
 */
class Photos
{
    /**   
     * @var integer $id
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */ 
    private $id;

    /**
     * @var string $path
     *
     * @ORM\Column(name="path", type="string", length=255, nullable=true)
     */
    private $path;
    
    /**
     * @var string $thumb1
     *
     * @ORM\Column(name="thumb1", type="string", length=255, nullable=true)
     */
    private $thumb1;
    
    /**
     * @var string $thumb2
     *
     * @ORM\Column(name="thumb2", type="string", length=255, nullable=true)
     */
    private $thumb2;
    
    /**
     * @var string $thumb3
     *
     * @ORM\Column(name="thumb3", type="string", length=255, nullable=true)
     */
    private $thumb3;
    
    /**
     * @var string $thumb4
     *
     * @ORM\Column(name="thumb4", type="string", length=255, nullable=true)
     */
    private $thumb4;
    
    /**
     * @var string $thumb5
     *
     * @ORM\Column(name="thumb5", type="string", length=255, nullable=true)
     */
    private $thumb5;
    
    /**
     * @var string $name
     *
     * @ORM\Column(name="name", type="string", length=255, nullable=true)
     */
    private $name;
    
    /**
     * @var string $title
     *
     * @ORM\Column(name="title", type="string", length=255, nullable=true)
     */
    private $title;
    
    /**
     * @var string $type
     *
     * @ORM\Column(name="type", type="string", length=50, nullable=true)
     */
    private $type;
    
    /**
     * @var string $tag
     *
     * @ORM\Column(name="tag", type="string", length=50, nullable=true)
     */
    private $tag;

    /**
     * @var datetime $published_at
     *
     * @ORM\Column(name="published_at", type="datetime", nullable=true)
     */
    private $published_at;

    /**
     * @var boolean $published
     *
     * @ORM\Column(name="published", type="boolean")
     */
    private $published;

    /**
     * @var integer $position
     *
     * @ORM\Column(name="position", type="integer", nullable=true)
     */
    private $position;
    
    /**
     * @var integer $height
     *
     * @ORM\Column(name="height", type="integer", nullable=true)
     */
    private $height;

    /**
     * @var integer $width
     *
     * @ORM\Column(name="width", type="integer", nullable=true)
     */
    private $width;
    
    /**
     * @var integer $heightThumb1
     *
     * @ORM\Column(name="heightThumb1", type="integer", nullable=true)
     */
    private $heightThumb1;

    /**
     * @var integer $widthThumb1
     *
     * @ORM\Column(name="widthThumb1", type="integer", nullable=true)
     */
    private $widthThumb1;
    
    /**
     * @var integer $heightThumb2
     *
     * @ORM\Column(name="heightThumb2", type="integer", nullable=true)
     */
    private $heightThumb2;

    /**
     * @var integer $widthThumb2
     *
     * @ORM\Column(name="widthThumb2", type="integer", nullable=true)
     */
    private $widthThumb2;
    
    /**
     * @var integer $heightThumb3
     *
     * @ORM\Column(name="heightThumb3", type="integer", nullable=true)
     */
    private $heightThumb3;

    /**
     * @var integer $widthThumb3
     *
     * @ORM\Column(name="widthThumb3", type="integer", nullable=true)
     */
    private $widthThumb3;
    
    /**
     * @var integer $heightThumb4
     *
     * @ORM\Column(name="heightThumb4", type="integer", nullable=true)
     */
    private $heightThumb4;

    /**
     * @var integer $widthThumb4
     *
     * @ORM\Column(name="widthThumb4", type="integer", nullable=true)
     */
    private $widthThumb4;
    
    /**
     * @var integer $heightThumb5
     *
     * @ORM\Column(name="heightThumb5", type="integer", nullable=true)
     */
    private $heightThumb5;

    /**
     * @var integer $widthThumb5
     *
     * @ORM\Column(name="widthThumb5", type="integer", nullable=true)
     */
    private $widthThumb5;
    
    /**
     * @var integer $size
     *
     * @ORM\Column(name="size", type="integer")
     */
    private $size;
    
    /**
     * @var string $idTemp
     *
     * @ORM\Column(name="idTemp", type="string", length=255, nullable=true)
     */
    private $idTemp;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\MairieBundle\Entity\Mairie", inversedBy="photos")
     */
    private $mairie;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\PageBundle\Entity\Page", inversedBy="photos")
     * @ORM\JoinColumn(name="page_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $page;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\PlanningBundle\Entity\Event", inversedBy="photos")
     * @ORM\JoinColumn(name="event_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $event;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\PageBundle\Entity\AlbumPhoto", inversedBy="photos")
     * @ORM\JoinColumn(name="album_photo_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $albumPhoto;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\PageBundle\Entity\Archive", inversedBy="photos")
     * @ORM\JoinColumn(name="archive_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $archive;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\PageBundle\Entity\Conseil", inversedBy="photos")
     * @ORM\JoinColumn(name="conseil_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $conseil;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\PageBundle\Entity\Plu", inversedBy="photos")
     * @ORM\JoinColumn(name="plu_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $plu;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\PageBundle\Entity\ConseilMembre", inversedBy="photos")
     * @ORM\JoinColumn(name="conseil_membre_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $membre;

    /**
     * @var string $titleDraft
     *
     * @ORM\Column(name="title_draft", type="string", length=255, nullable=true)
     */
    private $titleDraft;

    /**
     * @var boolean $deleted
     *
     * @ORM\Column(name="deleted", type="boolean", nullable=true)
     */
    private $deleted;

    private $filesToRemove = array();

    public function __construct()
    {
        $this->published = true;
        $this->state = "draft";
    }
    
    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set path
     *
     * @param string $path
     */
    public function setPath($path)
    {
        $this->path = $path;
    }

    /**
     * Get path
     *
     * @return string 
     */
    public function getPath()
    {
        return $this->path;
    }
    
    
    /**
     * Set path
     *
     * @param string $path
     */
    public function setThumb1($path)
    {
        $this->thumb1 = $path;
    }

    /**
     * Get path
     *
     * @return string 
     */
    public function getThumb1()
    {
        return $this->thumb1;
    }
    
    /**
     * Set title
     *
     * @param string $title
     */
    public function setTitle($title)
    {
        $this->title = $title;
    }

    /**
     * Get title
     *
     * @return string 
     */
    public function getTitle()
    {
        return $this->title;
    }
    
    
    /**
     * Set type
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }

    /**
     * Get type
     *
     * @return string 
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set created_at
     *
     * @param datetime $createdAt
     */
    public function setPublishedAt($publishedAt)
    {
        $this->published_at = $publishedAt;
    }

    /**
     * Get created_at
     *
     * @return datetime 
     */
    public function getPublishedAt()
    {
        return $this->published_at;
    }

    /**
     * Set published
     *
     * @param boolean $published
     */
    public function setPublished($published)
    {
        $this->published = $published;
    }

    /**
     * Get published
     *
     * @return boolean 
     */
    public function getPublished()
    {
        return $this->published;
    }

  /**
     * Set deleted
     *
     * @param boolean $deleted
     */
    public function setDeleted($deleted)
    {
        $this->deleted = $deleted;
    }
    
    /**
     * Get deleted
     *
     * @return boolean 
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set height
     *
     * @param integer $height
     */
    public function setHeight($height)
    {
        $this->height = $height;
    }

    /**
     * Get height
     *
     * @return integer 
     */
    public function getHeight()
    {
        return $this->height;
    }

    /**
     * Set width
     *
     * @param integer $width
     */
    public function setWidth($width)
    {
        $this->width = $width;
    }

    /**
     * Get width
     *
     * @return integer 
     */
    public function getWidth()
    {
        return $this->width;
    }

     /**
     * Set titleDraft
     *
     * @param string $titleDraft
     */
    public function setTitleDraft($titleDraft)
    {
        $this->titleDraft = $titleDraft;
    }

    /**
     * Get titleDraft
     *
     * @return string 
     */
    public function getTitleDraft()
    {
        return $this->titleDraft;
    }

    /**
     * @ORM\PreRemove
     */
    public function prepareRemoveFromDisk()
    {
        $this->filesToRemove = array(
            SYMFONY_KERNEL_ROOT_DIR . '/../web/' . $this->path,
            SYMFONY_KERNEL_ROOT_DIR . '/../web/' . $this->thumb1,
            SYMFONY_KERNEL_ROOT_DIR . '/../web/' . $this->thumb2,
            SYMFONY_KERNEL_ROOT_DIR . '/../web/' . $this->thumb3,
            SYMFONY_KERNEL_ROOT_DIR . '/../web/' . $this->thumb4,
            SYMFONY_KERNEL_ROOT_DIR . '/../web/' . $this->thumb5
        );
    }

    /**
     * @ORM\PreRemove
     */
    public function removeFromDisk()
    {
        foreach ($this->filesToRemove as $file) {
            @unlink($file);
        }
    }
    
    public function getUser()
    {
        return $this->user;
    }

    /**
     * Set user
     *
     * @param \MairieGestion\UserBundle\Entity\User $user
     * @return Photos
     */
    public function setUser(\MairieGestion\UserBundle\Entity\User $user = null)
    {
        $this->user = $user;
    
        return $this;
    }

    /**
     * Set thumb2
     *
     * @param string $thumb2
     * @return Photos
     */
    public function setThumb2($thumb2)
    {
        $this->thumb2 = $thumb2;
    
        return $this;
    }

    /**
     * Get thumb2
     *
     * @return string 
     */
    public function getThumb2()
    {
        return $this->thumb2;
    }

    /**
     * Set thumb3
     *
     * @param string $thumb3
     * @return Photos
     */
    public function setThumb3($thumb3)
    {
        $this->thumb3 = $thumb3;
    
        return $this;
    }

    /**
     * Get thumb3
     *
     * @return string 
     */
    public function getThumb3()
    {
        return $this->thumb3;
    }
    
    /**
     * Set thumb4
     *
     * @param string $thumb4
     * @return Photos
     */
    public function setThumb4($thumb4)
    {
        $this->thumb4 = $thumb4;
    
        return $this;
    }

    /**
     * Get thumb4
     *
     * @return string 
     */
    public function getThumb4()
    {
        return $this->thumb4;
    }
    
    /**
     * Set thumb5
     *
     * @param string $thumb5
     * @return Photos
     */
    public function setThumb5($thumb5)
    {
        $this->thumb5 = $thumb5;
    
        return $this;
    }

    /**
     * Get thumb5
     *
     * @return string 
     */
    public function getThumb5()
    {
        return $this->thumb5;
    }
    
    /**
     * Set mairie
     *
     * @param \MairieGestion\MairieBundle\Entity\Mairie $mairie
     * @return Photos
     */
    public function setMairie(\MairieGestion\MairieBundle\Entity\Mairie $mairie = null)
    {
        $this->mairie = $mairie;
    
        return $this;
    }

    /**
     * Get mairie
     *
     * @return \MairieGestion\MairieBundle\Entity\Mairie 
     */
    public function getMairie()
    {
        return $this->mairie;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return Photos
     */
    public function setName($name)
    {
        $this->name = $name;
    
        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set tag
     *
     * @param string $tag
     * @return Photos
     */
    public function setTag($tag)
    {
        $this->tag = $tag;
    
        return $this;
    }

    /**
     * Get tag
     *
     * @return string 
     */
    public function getTag()
    {
        return $this->tag;
    }

    /**
     * Set size
     *
     * @param integer $size
     * @return Photos
     */
    public function setSize($size)
    {
        $this->size = $size;
    
        return $this;
    }

    /**
     * Get size
     *
     * @return integer 
     */
    public function getSize()
    {
        return $this->size;
    }

    /**
     * Set heightThumb1
     *
     * @param integer $heightThumb1
     * @return Photos
     */
    public function setHeightThumb1($heightThumb1)
    {
        $this->heightThumb1 = $heightThumb1;
    
        return $this;
    }

    /**
     * Get heightThumb1
     *
     * @return integer 
     */
    public function getHeightThumb1()
    {
        return $this->heightThumb1;
    }

    /**
     * Set widthThumb1
     *
     * @param integer $widthThumb1
     * @return Photos
     */
    public function setWidthThumb1($widthThumb1)
    {
        $this->widthThumb1 = $widthThumb1;
    
        return $this;
    }

    /**
     * Get widthThumb1
     *
     * @return integer 
     */
    public function getWidthThumb1()
    {
        return $this->widthThumb1;
    }

    /**
     * Set heightThumb2
     *
     * @param integer $heightThumb2
     * @return Photos
     */
    public function setHeightThumb2($heightThumb2)
    {
        $this->heightThumb2 = $heightThumb2;
    
        return $this;
    }

    /**
     * Get heightThumb2
     *
     * @return integer 
     */
    public function getHeightThumb2()
    {
        return $this->heightThumb2;
    }

    /**
     * Set widthThumb2
     *
     * @param integer $widthThumb2
     * @return Photos
     */
    public function setWidthThumb2($widthThumb2)
    {
        $this->widthThumb2 = $widthThumb2;
    
        return $this;
    }

    /**
     * Get widthThumb2
     *
     * @return integer 
     */
    public function getWidthThumb2()
    {
        return $this->widthThumb2;
    }

    /**
     * Set heightThumb3
     *
     * @param integer $heightThumb3
     * @return Photos
     */
    public function setHeightThumb3($heightThumb3)
    {
        $this->heightThumb3 = $heightThumb3;
    
        return $this;
    }

    /**
     * Get heightThumb3
     *
     * @return integer 
     */
    public function getHeightThumb3()
    {
        return $this->heightThumb3;
    }

    /**
     * Set widthThumb3
     *
     * @param integer $widthThumb3
     * @return Photos
     */
    public function setWidthThumb3($widthThumb3)
    {
        $this->widthThumb3 = $widthThumb3;
    
        return $this;
    }

    /**
     * Get widthThumb3
     *
     * @return integer 
     */
    public function getWidthThumb3()
    {
        return $this->widthThumb3;
    }


    /**
     * Set heightThumb4
     *
     * @param integer $heightThumb4
     * @return Photos
     */
    public function setHeightThumb4($heightThumb4)
    {
        $this->heightThumb4 = $heightThumb4;
    
        return $this;
    }

    /**
     * Get heightThumb4
     *
     * @return integer 
     */
    public function getHeightThumb4()
    {
        return $this->heightThumb4;
    }

    /**
     * Set widthThumb4
     *
     * @param integer $widthThumb4
     * @return Photos
     */
    public function setWidthThumb4($widthThumb4)
    {
        $this->widthThumb4 = $widthThumb4;
    
        return $this;
    }

    /**
     * Get widthThumb4
     *
     * @return integer 
     */
    public function getWidthThumb4()
    {
        return $this->widthThumb4;
    }
    

    /**
     * Set heightThumb5
     *
     * @param integer $heightThumb5
     * @return Photos
     */
    public function setHeightThumb5($heightThumb5)
    {
        $this->heightThumb5 = $heightThumb5;
    
        return $this;
    }

    /**
     * Get heightThumb5
     *
     * @return integer 
     */
    public function getHeightThumb5()
    {
        return $this->heightThumb5;
    }

    /**
     * Set widthThumb5
     *
     * @param integer $widthThumb5
     * @return Photos
     */
    public function setWidthThumb5($widthThumb5)
    {
        $this->widthThumb5 = $widthThumb5;
    
        return $this;
    }

    /**
     * Get widthThumb5
     *
     * @return integer 
     */
    public function getWidthThumb5()
    {
        return $this->widthThumb5;
    }
    
    /**
     * Set idTemp
     *
     * @param integer $idTemp
     * @return Photos
     */
    public function setIdTemp($idTemp)
    {
        $this->idTemp = $idTemp;
    
        return $this;
    }

    /**
     * Get idTemp
     *
     * @return integer 
     */
    public function getIdTemp()
    {
        return $this->idTemp;
    }

    /**
     * Set page
     *
     * @param \MairieGestion\PageBundle\Entity\Page $page
     * @return Photos
     */
    public function setPage(\MairieGestion\PageBundle\Entity\Page $page = null)
    {
        $this->page = $page;
    
        return $this;
    }

    /**
     * Get page
     *
     * @return \MairieGestion\PageBundle\Entity\Page 
     */
    public function getPage()
    {
        return $this->page;
    }

    /**
     * Set archive
     *
     * @param \MairieGestion\PageBundle\Entity\Archive $archive
     * @return Photos
     */
    public function setArchive(\MairieGestion\PageBundle\Entity\Archive $archive = null)
    {
        $this->archive = $archive;
    
        return $this;
    }

    /**
     * Get archive
     *
     * @return \MairieGestion\PageBundle\Entity\Archive 
     */
    public function getArchive()
    {
        return $this->archive;
    }

    /**
     * Set conseil
     *
     * @param \MairieGestion\PageBundle\Entity\Conseil $conseil
     * @return Photos
     */
    public function setConseil(\MairieGestion\PageBundle\Entity\Conseil $conseil = null)
    {
        $this->conseil = $conseil;
    
        return $this;
    }

    /**
     * Get conseil
     *
     * @return \MairieGestion\PageBundle\Entity\Conseil 
     */
    public function getConseil()
    {
        return $this->conseil;
    }

    /**
     * Set membre
     *
     * @param \MairieGestion\PageBundle\Entity\ConseilMembre $membre
     * @return Photos
     */
    public function setMembre(\MairieGestion\PageBundle\Entity\ConseilMembre $membre = null)
    {
        $this->membre = $membre;
    
        return $this;
    }

    /**
     * Get membre
     *
     * @return \MairieGestion\PageBundle\Entity\ConseilMembre 
     */
    public function getMembre()
    {
        return $this->membre;
    }

    /**
     * Set plu
     *
     * @param \MairieGestion\PageBundle\Entity\Plu $plu
     * @return Photos
     */
    public function setPlu(\MairieGestion\PageBundle\Entity\Plu $plu = null)
    {
        $this->plu = $plu;
    
        return $this;
    }

    /**
     * Get plu
     *
     * @return \MairieGestion\PageBundle\Entity\Plu 
     */
    public function getPlu()
    {
        return $this->plu;
    }

    /**
     * Set albumPhoto
     *
     * @param \MairieGestion\PageBundle\Entity\AlbumPhoto $albumPhoto
     * @return Photos
     */
    public function setAlbumPhoto(\MairieGestion\PageBundle\Entity\AlbumPhoto $albumPhoto = null)
    {
        $this->albumPhoto = $albumPhoto;
    
        return $this;
    }

    /**
     * Get albumPhoto
     *
     * @return \MairieGestion\PageBundle\Entity\AlbumPhoto 
     */
    public function getAlbumPhoto()
    {
        return $this->albumPhoto;
    }

    /**
     * Set event
     *
     * @param \MairieGestion\PlanningBundle\Entity\Event $event
     * @return Photos
     */
    public function setEvent(\MairieGestion\PlanningBundle\Entity\Event $event = null)
    {
        $this->event = $event;
    
        return $this;
    }

    /**
     * Get event
     *
     * @return \MairieGestion\PlanningBundle\Entity\Event 
     */
    public function getEvent()
    {
        return $this->event;
    }

    /**
     * Set position
     *
     * @param integer $position
     * @return Photos
     */
    public function setPosition($position)
    {
        $this->position = $position;
    
        return $this;
    }

    /**
     * Get position
     *
     * @return integer 
     */
    public function getPosition()
    {
        return $this->position;
    }
}