<?php

namespace MairieGestion\MainBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class FileReaderType extends AbstractType
{
    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $view->vars['function'] = $options['function'];
        if (isset($options['max_length']))
            $view->vars['post_max_size'] = $options['max_length'];
        else
            $view->vars['post_max_size'] = UploadedFile::getMaxFilesize();
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(array(
            'function' => 'MairieGestionFilereaderUpload',
        ));
    }

    public function getName()
    {
        return 'mairiegestion_filereader';
    }

    public function getParent()
    {
        return 'file';
    }
}
