<?php

namespace MairieGestion\MainBundle\Listener;

use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpKernel\Event\GetResponseForExceptionEvent;
use Symfony\Component\Security\Core\Exception\AccessDeniedException as AccessDeniedException;
use Symfony\Component\HttpKernel\Exception\HttpException;

/**
 * Exception Handler
 *
 */
class ExceptionListener implements EventSubscriberInterface
{
    protected $container;
    protected $router;

    public function __construct($container, $router)
    {
        $this->container = $container;
        $this->router = $router;
    }

    public static function getSubscribedEvents()
    {
        return array(
            KernelEvents::CONTROLLER => array(array('onKernelException', 17)),
        );
    }

    /**
     * Handles security related exceptions.
     *
     * @param GetResponseForExceptionEvent $event An GetResponseForExceptionEvent instance
     */
    public function onKernelException($event)
    {
        $request = $event->getRequest();
        $route = $request->attributes->get('_route');
        $user = $this->container->get('security.context')->getToken()?$this->container->get('security.context')->getToken()->getUser():false;
        if ($route && is_object($user) && !$user->getMairie()->getDescription() && $request->attributes->get('_route') != 'param_generale')
        {
            $controller = $event->getController();
            $controller = $controller[0];
            throw new HttpException(307, null, null, array('Location' => $controller->generateUrl('param_generale')));
        }
    }
}
