<?php

namespace MairieGestion\MairieBundle\Command;

use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\ArgvInput;
use Symfony\Component\Console\Output\OutputInterface;
use MairieGestion\UserBundle\Entity\User;
use MairieGestion\MairieBundle\Entity\Mairie;
use MairieGestion\PageBundle\Entity\Page;

class CreateMairieLightCommand extends ContainerAwareCommand
{
    /**
     * @see Command
     */
    protected function configure()
    {
        $this
            ->setName('test')
            ->setDescription('Creation d\'une mairie.')
            ->addArgument(
                'mairie_name',
                InputArgument::REQUIRED,
                'Quel est le nom de votre mairie ?'
            )
            ->addArgument(
                'domaine',
                InputArgument::REQUIRED,
                'Quel est domaine de votre mairie ?'
            )
            ->addArgument(
                'email',
                InputArgument::REQUIRED,
                'Quel est domaine de votre mairie ?'
            )
            ->addArgument(
                'password',
                InputArgument::REQUIRED,
                'Quel est domaine de votre mairie ?'
            );
    }

    /**
     * @see Command
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $mairie_name = $input->getArgument('mairie_name');
        $domaine = $input->getArgument('domaine');
        $email = $input->getArgument('email');
        $password = $input->getArgument('password');

        $tab = explode('.',$domaine);
        
        if (count($tab) == 3)
        {
            $em = $this->getContainer()->get('doctrine')->getManager();
            
            $mairie = new Mairie();
            $mairie->setName($mairie_name);
            $mairie->setDomaine($domaine);
            $em->persist($mairie);
            
            $user = new User();
            
            $user->setMairie($mairie);
            $user->setUsername(uniqid());
            $user->setEmail($email);
            $user->setPlainPassword($password);
            $user->setRoles(array('ROLE_ADMIN'));
            
            $em->persist($user);
            
            $page = new Page();
            $page->setMairie($mairie);
            $page->setName('Accueil');
            $page->setPath('');
            $page->setOnline(true);
            $page->setInMenu(true);
            $page->setHome(true);
            $page->setPosition(1);
            
            $em->persist($page);
            
            $em->flush();
            
            $output->writeln(sprintf('Creation en BDD du site pour le domaine <comment>%s</comment>', $domaine));
            $path_a = '/etc/apache2/sites-available/';
            $path_e = '/etc/apache2/sites-enabled/';
            
            $filename = $tab[1].'.'.$tab[2];
            $file_a = $path_a.$filename;
            $file_e = $path_e.$filename;
            $output->writeln(sprintf('toto'));
            if (!file_exists($file_a))
            {
                $fp = fopen($file_a,'w');
                fwrite($fp,$this->generateVirtualHost($domaine,true));
                exec('ln -s ../sites-available/'.$filename.' '.$file_e);
                fclose($fp);
            }
            else
            {
                $fp = fopen($file_a,'a+');
                fwrite($fp,$this->generateVirtualHost($domaine,false));
                fclose($fp);
            }
            exec('service apache2 restart');
            $output->writeln(sprintf('Creation du site <comment>%s</comment> bien effectuée', $domaine));
        }
        else
            $output->writeln(sprintf('<error>Domaine incorect</error> '));
    }

    private function generateVirtualHost($domaine,$new_file=false)
    {
        $tab = explode('.',$domaine);
        return ($new_file?
'<VirtualHost *:80>
    ServerName '.$tab[1].'.'.$tab[2].'
    Options +FollowSymlinks
    RewriteEngine on
    RewriteCond %{HTTP_HOST} ^'.$tab[1].'.'.$tab[2].'$
    RewriteRule ^(.*) http://'.$domaine.'$1 [QSA,L,R=301]
</VirtualHost>'."\n":'').
'<VirtualHost *:80>
    ServerAdmin webmaster@localhost
    ServerName '.$domaine.'

    DocumentRoot /var/www/mairiegestion_prod/web
    <Directory /var/www/mairiegestion_prod/web/>
        Options Indexes FollowSymLinks MultiViews
        AllowOverride All
        Order allow,deny
        allow from all
        <IfModule mod_rewrite.c>
            RewriteEngine On
            RewriteCond %{REQUEST_FILENAME} !-f
            RewriteRule ^(.*)$ /app.php [QSA,L]
        </IfModule>
        <IfModule mod_rewrite.c>
            RewriteEngine On
            RewriteCond %{HTTP_HOST} ^'.$tab[1].'.'.$tab[2].'$
            RewriteRule ^(.*) http://'.$domaine.'/$1 [QSA,L,R=301]
        </IfModule>
    </Directory>
</VirtualHost>'."\n";
    }
}
