<?php

namespace MairieGestion\MairieBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\Form\FormError;

use MairieGestion\UserBundle\Entity\User;
use MairieGestion\MairieBundle\Entity\Mairie;
use MairieGestion\MairieBundle\Form\MairieType;

class DefaultController extends Controller
{
    /**
     * @Route("/super-admin/mairie/nouveau", name="mairie_new")
     * @Template()
     */
    public function newMairieAction()
    {
        $request = $this->getRequest();
        $message = '';
        // $request = $this->getRequest()->createFromGlobals();
        $user = $this->container->get('security.context')->getToken()->getUser();
        $em = $this->getDoctrine()->getEntityManager();
        $form       = $this->createForm(new MairieType());
        if ($request->getMethod() == 'POST') {
            $vars = $request->request->get('mairietype');
            $form->bind($request);
            if ($vars['domaine'] && count(explode('.',$vars['domaine'])) != 3)
                $form->get('domaine')->addError(new FormError('Nom de domaine incorrect (ex: www.mondomaine.com)'));
            elseif($vars['domaine'] && count($em->getRepository('MairieGestionMairieBundle:Mairie')->getMairieByShortDomaine($vars['domaine'])))
                $form->get('domaine')->addError(new FormError('Ce nom de domaine existe déjà'));
            if($vars['email'] && count($em->getRepository('MairieGestionUserBundle:User')->getUsersByEmail($vars['email'])))
                $form->get('email')->addError(new FormError('Cette adresse email est déjà utilisée'));
            if($form->isValid()) {
                $commande = $this->container->get('kernel')->getRootDir().'/console test "'.$vars['name'].'" "'.$vars['domaine'].'" "'.$vars['email'].'" "'.$vars['password'].'"';
                $message = exec($commande);
           }
        }
        return array(
            'message' => $message,
            'form'       => $form->createView(),
        );
    }
}
