<?php

namespace MairieGestion\MairieBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Validator\Constraints\Email;

/**
 * Mairie
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="MairieGestion\MairieBundle\Entity\MairieRepository")
 */
class Mairie
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=255)
     * @Assert\NotBlank(message="Veuillez renseigner le nom de votre mairie")
     * @Assert\Length(max=100,min=2)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="domaine", type="string", length=255, unique=true)
     * @Assert\NotBlank(message="Veuillez renseigner le domaine de votre site internet")
     * @Assert\Length(max=254,min=3)
     */
    private $domaine;
    
    /**
     * @var string
     *
     * @ORM\Column(name="tel", type="string", length=255, nullable=true)
     * @Assert\NotBlank(message="Veuillez renseigner le numéro de téléphone de votre mairie")
     * @Assert\Length(max=254,min=10)
     */
    private $tel;
    
    /**
     * @var string
     *
     * @ORM\Column(name="fax", type="string", length=255, nullable=true)
     */
    private $fax;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="nb_habitant", type="integer", nullable=true)
     */
    private $nbHabitant;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="display_nb_habitant", type="boolean", nullable=true)
     */
    private $displayNbHabitant;
    
    /**
     * @var string
     *
     * @ORM\Column(name="email", type="string", length=255,nullable=true)
     * @Assert\NotBlank(message="Veuillez renseigner l'email de contact de votre mairie")
     * @Assert\Length(max=254,min=5)
     * @Assert\Email
     */
    private $email;
    
    /**
     * @var text
     *
     * @ORM\Column(name="horaire", type="text",nullable=true)
     * @Assert\NotBlank(message="Veuillez renseigner les horaires de votre mairie")
     */
    private $horaire;
    
    /**
     * @var text
     *
     * @ORM\Column(name="description", type="text",nullable=true)
     * @Assert\NotBlank(message="Veuillez présenter votre mairie")
     */
    private $description;
    
    /**
     * @var string
     *
     * @ORM\Column(name="meta_title", type="string", length=255,nullable=true)
     */
    private $metaTitle;
    
    /**
     * @var text
     *
     * @ORM\Column(name="meta_description", type="text",nullable=true)
     */
    private $metaDescription;
    
    /**
     * @var text
     *
     * @ORM\Column(name="google_analytics", type="text",nullable=true)
     */
    private $googleAnalytics;
    
    /**
     * @var string
     *
     * @ORM\Column(name="google_verification", type="string", length=255,nullable=true)
     */
    private $googleVerification;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_menu", type="string", length=255,nullable=true)
     */
    private $couleurMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_texte_menu", type="string", length=255,nullable=true)
     */
    private $couleurTexteMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_ombre_texte_menu", type="string", length=255,nullable=true)
     */
    private $couleurOmbreTexteMenu;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="ombre_texte_menu", type="boolean", nullable=true)
     */
    private $ombreTexteMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_hover_texte_menu", type="string", length=255,nullable=true)
     */
    private $couleurHoverTexteMenu;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="hover_texte_menu", type="boolean", length=255,nullable=true)
     */
    private $hoverTexteMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_hover_background_menu", type="string", length=255,nullable=true)
     */
    private $couleurHoverBackgroundMenu;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="hover_background_menu", type="boolean", nullable=true)
     */
    private $hoverBackgroundMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_sous_menu", type="string", length=255,nullable=true)
     */
    private $couleurSousMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_texte_sous_menu", type="string", length=255,nullable=true)
     */
    private $couleurTexteSousMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_ombre_texte_sous_menu", type="string", length=255,nullable=true)
     */
    private $couleurOmbreTexteSousMenu;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="ombre_texte_sous_menu", type="boolean", nullable=true)
     */
    private $ombreTexteSousMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_hover_texte_sous_menu", type="string", length=255,nullable=true)
     */
    private $couleurHoverTexteSousMenu;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="hover_texte_sous_menu", type="boolean", length=255,nullable=true)
     */
    private $hoverTexteSousMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_hover_background_sous_menu", type="string", length=255,nullable=true)
     */
    private $couleurHoverBackgroundSousMenu;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="hover_background_sous_menu", type="boolean", nullable=true)
     */
    private $hoverBackgroundSousMenu;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_background", type="string", length=255,nullable=true)
     */
    private $couleurBackground;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="intensity_background", type="smallint", nullable=true)
     */
    private $intensityBackground;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="background_page", type="boolean", nullable=true)
     */
    private $backgroundPage;
    
    /**
     * @var string
     *
     * @ORM\Column(name="couleur_background_page", type="string", length=255,nullable=true)
     */
    private $couleurBackgroundPage;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="intensity_background_page", type="smallint", nullable=true)
     */
    private $intensityBackgroundPage;
    
    /**
     * @var boolean
     *
     * @ORM\Column(name="onglet_actif_menu", type="boolean", nullable=true)
     */
    private $ongletActifMenu;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\PageBundle\Entity\PatternBackground", inversedBy="mairies", cascade={"persist"})
     */
    private $patternBackground;
    
    /**
     * @ORM\OneToOne(targetEntity="MairieGestion\MainBundle\Entity\Photos", cascade={"persist", "remove"})
     * @ORM\JoinColumn(onDelete="SET NULL")
     * @Assert\Valid()
     */
    protected $imgHeader;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\MainBundle\Entity\Photos", mappedBy="mairie")
     */
    private $photos;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\UserBundle\Entity\User", mappedBy="mairie")
     */
    private $users;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\Carte", mappedBy="mairie")
     */
    private $cartes;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\Album", mappedBy="mairie")
     */
    private $albums;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\AlbumPhoto", mappedBy="mairie")
     */
    private $albumPhotos;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\Plu", mappedBy="mairie")
     */
    private $plus;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\Conseil", mappedBy="mairie")
     */
    private $conseils;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\Archive", mappedBy="mairie")
     */
    private $archives;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\Lieu", mappedBy="mairie")
     */
    private $lieux;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\Page", mappedBy="mairie")
     */
    private $pages;
    
    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PlanningBundle\Entity\Event", mappedBy="mairie")
     */
    private $events;
    
    /**
     * @ORM\ManyToOne(targetEntity="MairieGestion\MainBundle\Entity\Adresse", cascade={"persist"})
     */
    private $adresse;
    
    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return Mairie
     */
    public function setName($name)
    {
        $this->name = $name;
    
        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set domaine
     *
     * @param integer $domaine
     * @return Mairie
     */
    public function setDomaine($domaine)
    {
        $this->domaine = $domaine;
    
        return $this;
    }

    /**
     * Get domaine
     *
     * @return integer 
     */
    public function getDomaine()
    {
        return $this->domaine;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->users = new \Doctrine\Common\Collections\ArrayCollection();
        $this->pages = new \Doctrine\Common\Collections\ArrayCollection();
        $this->displayNbHabitant = true;
        $this->couleurMenu = '#ffffff';
        $this->couleurTexteMenu = '#777777';
        $this->ombreTexteMenu = true;
        $this->couleurOmbreTexteMenu = '#ffffff';
        $this->hoverTexteMenu = true;
        $this->couleurHoverTexteMenu = '#999999';
        $this->hoverBackgroundMenu = false;
        
        $this->couleurSousMenu = '#ffffff';
        $this->couleurTexteSousMenu = '#777777';
        $this->ombreTexteSousMenu = true;
        $this->couleurOmbreTexteSousMenu = '#ffffff';
        $this->hoverTexteSousMenu = true;
        $this->couleurHoverTexteSousMenu = '#ffffff';
        $this->hoverBackgroundSousMenu = true;
        $this->couleurHoverBackgroundMenu = '#0081c2';
        
        $this->couleurBackground = '#ffffff';
        $this->intensityBackground = 10;
    }
    
    /**
     * Add users
     *
     * @param \MairieGestion\UserBundle\Entity\User $users
     * @return Mairie
     */
    public function addUser(\MairieGestion\UserBundle\Entity\User $users)
    {
        $this->users[] = $users;
    
        return $this;
    }

    /**
     * Remove users
     *
     * @param \MairieGestion\UserBundle\Entity\User $users
     */
    public function removeUser(\MairieGestion\UserBundle\Entity\User $users)
    {
        $this->users->removeElement($users);
    }

    /**
     * Get users
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getUsers()
    {
        return $this->users;
    }

    /**
     * Add pages
     *
     * @param \MairieGestion\PageBundle\Entity\Page $pages
     * @return Mairie
     */
    public function addPage(\MairieGestion\PageBundle\Entity\Page $pages)
    {
        $this->pages[] = $pages;
    
        return $this;
    }

    /**
     * Remove pages
     *
     * @param \MairieGestion\PageBundle\Entity\Page $pages
     */
    public function removePage(\MairieGestion\PageBundle\Entity\Page $pages)
    {
        $this->pages->removeElement($pages);
    }

    /**
     * Get pages
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPages()
    {
        return $this->pages;
    }

    /**
     * Set adresse
     *
     * @param \MairieGestion\MainBundle\Entity\Adresse $adresse
     * @return Mairie
     */
    public function setAdresse(\MairieGestion\MainBundle\Entity\Adresse $adresse = null)
    {
        $this->adresse = $adresse;
    
        return $this;
    }

    /**
     * Get adresse
     *
     * @return \MairieGestion\MainBundle\Entity\Adresse 
     */
    public function getAdresse()
    {
        return $this->adresse;
    }

    /**
     * Set tel
     *
     * @param string $tel
     * @return Mairie
     */
    public function setTel($tel)
    {
        $this->tel = $tel;
    
        return $this;
    }

    /**
     * Get tel
     *
     * @return string 
     */
    public function getTel()
    {
        return $this->tel;
    }

    /**
     * Set fax
     *
     * @param string $fax
     * @return Mairie
     */
    public function setFax($fax)
    {
        $this->fax = $fax;
    
        return $this;
    }

    /**
     * Get fax
     *
     * @return string 
     */
    public function getFax()
    {
        return $this->fax;
    }

    /**
     * Set email
     *
     * @param string $email
     * @return Mairie
     */
    public function setEmail($email)
    {
        $this->email = $email;
    
        return $this;
    }

    /**
     * Get email
     *
     * @return string 
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Set horaire
     *
     * @param string $horaire
     * @return Mairie
     */
    public function setHoraire($horaire)
    {
        $this->horaire = $horaire;
    
        return $this;
    }

    /**
     * Get horaire
     *
     * @return string 
     */
    public function getHoraire()
    {
        return $this->horaire;
    }

    /**
     * Set description
     *
     * @param string $description
     * @return Mairie
     */
    public function setDescription($description)
    {
        $this->description = $description;
    
        return $this;
    }

    /**
     * Get description
     *
     * @return string 
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Set imgHeader
     *
     * @param \MairieGestion\MainBundle\Entity\Photos $imgHeader
     * @return Mairie
     */
    public function setImgHeader(\MairieGestion\MainBundle\Entity\Photos $imgHeader = null)
    {
        $this->imgHeader = $imgHeader;
    
        return $this;
    }

    /**
     * Get imgHeader
     *
     * @return \MairieGestion\MainBundle\Entity\Photos 
     */
    public function getImgHeader()
    {
        return $this->imgHeader;
    }
    
    public function getImgHeaderImg()
    {
        if (is_object($this->imgHeader))
        	return $this->imgHeader->getPath();
        return $this->getImgHeaderDefaultImg(); 
    }
    
    public function getImgHeaderDefaultImg()
    {
        return 'img/design/avatar-man.jpg'; 
    }

    /**
     * Add photos
     *
     * @param \MairieGestion\MainBundle\Entity\Photos $photos
     * @return Mairie
     */
    public function addPhoto(\MairieGestion\MainBundle\Entity\Photos $photos)
    {
        $this->photos[] = $photos;
    
        return $this;
    }

    /**
     * Remove photos
     *
     * @param \MairieGestion\MainBundle\Entity\Photos $photos
     */
    public function removePhoto(\MairieGestion\MainBundle\Entity\Photos $photos)
    {
        $this->photos->removeElement($photos);
    }

    /**
     * Get photos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPhotos()
    {
        $photos = array();
        foreach($this->photos as $photo)
            if ($photo->getTag() == 'photo_mairie' && $photo->getPublished())
                $photos[] = $photo;
        usort($photos, function ($a, $b) {
            $a_value = $a->getPosition()===null?(9999999):$a->getPosition();
            $b_value = $b->getPosition()===null?(9999999):$b->getPosition();
            return strcmp($a_value, $b_value);
        });
        return $photos;
    }
    
    /**
     * Get photos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPhotosArchives()
    {
        $photos = array();
        foreach($this->photos as $photo)
            if (!$photo->getPublished())
                $photos[] = $photo;
        return $photos;
    }

    public function getBulletinsMunicipaux()
    {
        $photos = array();
        foreach($this->photos as $photo)
            if ($photo->getTag() == 'bulletins_municipaux')
                $photos[] = $photo;
        return $photos;
    }
    
    public function getPhotosUrl()
    {
        $photos = array();
        foreach($this->photos as $photo)
            if ($photo->getTag() == 'photo_url')
                $photos[] = $photo;
        return $photos;
    }
    
    /**
     * Set coordonnesGoogleMap
     *
     * @param string $coordonnesGoogleMap
     * @return Mairie
     */
    public function setCoordonnesGoogleMap($coordonnesGoogleMap)
    {
        $this->coordonnesGoogleMap = $coordonnesGoogleMap;
    
        return $this;
    }

    /**
     * Get coordonnesGoogleMap
     *
     * @return string 
     */
    public function getCoordonnesGoogleMap()
    {
        return $this->coordonnesGoogleMap;
    }

    /**
     * Add cartes
     *
     * @param \MairieGestion\PageBundle\Entity\Carte $cartes
     * @return Mairie
     */
    public function addCarte(\MairieGestion\PageBundle\Entity\Carte $cartes)
    {
        $this->cartes[] = $cartes;
    
        return $this;
    }

    /**
     * Remove cartes
     *
     * @param \MairieGestion\PageBundle\Entity\Carte $cartes
     */
    public function removeCarte(\MairieGestion\PageBundle\Entity\Carte $cartes)
    {
        $this->cartes->removeElement($cartes);
    }

    /**
     * Get cartes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCartes()
    {
        return $this->cartes;
    }

    /**
     * Add lieux
     *
     * @param \MairieGestion\PageBundle\Entity\Lieu $lieux
     * @return Mairie
     */
    public function addLieux(\MairieGestion\PageBundle\Entity\Lieu $lieux)
    {
        $this->lieux[] = $lieux;
    
        return $this;
    }

    /**
     * Remove lieux
     *
     * @param \MairieGestion\PageBundle\Entity\Lieu $lieux
     */
    public function removeLieux(\MairieGestion\PageBundle\Entity\Lieu $lieux)
    {
        $this->lieux->removeElement($lieux);
    }

    /**
     * Get lieux
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getLieux()
    {
        return $this->lieux;
    }

    /**
     * Set metaTitle
     *
     * @param string $metaTitle
     * @return Mairie
     */
    public function setMetaTitle($metaTitle)
    {
        $this->metaTitle = $metaTitle;
    
        return $this;
    }

    /**
     * Get metaTitle
     *
     * @return string 
     */
    public function getMetaTitle()
    {
        return $this->metaTitle;
    }

    /**
     * Set metaDescription
     *
     * @param string $metaDescription
     * @return Mairie
     */
    public function setMetaDescription($metaDescription)
    {
        $this->metaDescription = $metaDescription;
    
        return $this;
    }

    /**
     * Get metaDescription
     *
     * @return string 
     */
    public function getMetaDescription()
    {
        return $this->metaDescription;
    }

    /**
     * Set googleAnalytics
     *
     * @param string $googleAnalytics
     * @return Mairie
     */
    public function setGoogleAnalytics($googleAnalytics)
    {
        $this->googleAnalytics = $googleAnalytics;
    
        return $this;
    }

    /**
     * Get googleAnalytics
     *
     * @return string 
     */
    public function getGoogleAnalytics()
    {
        return $this->googleAnalytics;
    }

    /**
     * Set googleVerification
     *
     * @param string $googleVerification
     * @return Mairie
     */
    public function setGoogleVerification($googleVerification)
    {
        $this->googleVerification = $googleVerification;
    
        return $this;
    }

    /**
     * Get googleVerification
     *
     * @return string 
     */
    public function getGoogleVerification()
    {
        return $this->googleVerification;
    }

    /**
     * Add archives
     *
     * @param \MairieGestion\PageBundle\Entity\Archive $archives
     * @return Mairie
     */
    public function addArchive(\MairieGestion\PageBundle\Entity\Archive $archives)
    {
        $this->archives[] = $archives;
    
        return $this;
    }

    /**
     * Remove archives
     *
     * @param \MairieGestion\PageBundle\Entity\Archive $archives
     */
    public function removeArchive(\MairieGestion\PageBundle\Entity\Archive $archives)
    {
        $this->archives->removeElement($archives);
    }

    /**
     * Get archives
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getArchives()
    {
        return $this->archives;
    }
    
    public function getArchivesActive()
    {
        $archives = array();
        foreach($this->archives as $archive)
            if ($archive->getActive())
                $archives[] = $archive;
        return $archives;
    }

    /**
     * Add conseils
     *
     * @param \MairieGestion\PageBundle\Entity\Conseil $conseils
     * @return Mairie
     */
    public function addConseil(\MairieGestion\PageBundle\Entity\Conseil $conseils)
    {
        $this->conseils[] = $conseils;
    
        return $this;
    }

    /**
     * Remove conseils
     *
     * @param \MairieGestion\PageBundle\Entity\Conseil $conseils
     */
    public function removeConseil(\MairieGestion\PageBundle\Entity\Conseil $conseils)
    {
        $this->conseils->removeElement($conseils);
    }

    /**
     * Get conseils
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getConseils()
    {
        return $this->conseils;
    }
    
    public function getConseilCourant()
    {
        foreach($this->conseils as $conseil)
            if (!$conseil->getAnneeEnd())
                return $conseil;
        foreach($this->conseils as $conseil)
            if ($conseil->getAnneeEnd() >= date('Y'))
                return $conseil;
        return null;
    }

    /**
     * Add plus
     *
     * @param \MairieGestion\PageBundle\Entity\Plu $plus
     * @return Mairie
     */
    public function addPlu(\MairieGestion\PageBundle\Entity\Plu $plus)
    {
        $this->plus[] = $plus;
    
        return $this;
    }

    /**
     * Remove plus
     *
     * @param \MairieGestion\PageBundle\Entity\Plu $plus
     */
    public function removePlu(\MairieGestion\PageBundle\Entity\Plu $plus)
    {
        $this->plus->removeElement($plus);
    }

    /**
     * Get plus
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPlus()
    {
        return $this->plus;
    }

    /**
     * Add albums
     *
     * @param \MairieGestion\PageBundle\Entity\Album $albums
     * @return Mairie
     */
    public function addAlbum(\MairieGestion\PageBundle\Entity\Album $albums)
    {
        $this->albums[] = $albums;
    
        return $this;
    }

    /**
     * Remove albums
     *
     * @param \MairieGestion\PageBundle\Entity\Album $albums
     */
    public function removeAlbum(\MairieGestion\PageBundle\Entity\Album $albums)
    {
        $this->albums->removeElement($albums);
    }

    /**
     * Get albums
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAlbums()
    {
        return $this->albums;
    }

    /**
     * Add albumPhotos
     *
     * @param \MairieGestion\PageBundle\Entity\AlbumPhoto $albumPhotos
     * @return Mairie
     */
    public function addAlbumPhoto(\MairieGestion\PageBundle\Entity\AlbumPhoto $albumPhotos)
    {
        $this->albumPhotos[] = $albumPhotos;
    
        return $this;
    }

    /**
     * Remove albumPhotos
     *
     * @param \MairieGestion\PageBundle\Entity\AlbumPhoto $albumPhotos
     */
    public function removeAlbumPhoto(\MairieGestion\PageBundle\Entity\AlbumPhoto $albumPhotos)
    {
        $this->albumPhotos->removeElement($albumPhotos);
    }

    /**
     * Get albumPhotos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAlbumPhotos()
    {
        return $this->albumPhotos;
    }

    /**
     * Add events
     *
     * @param \MairieGestion\PlanningBundle\Entity\Event $events
     * @return Mairie
     */
    public function addEvent(\MairieGestion\PlanningBundle\Entity\Event $events)
    {
        $this->events[] = $events;
    
        return $this;
    }

    /**
     * Remove events
     *
     * @param \MairieGestion\PlanningBundle\Entity\Event $events
     */
    public function removeEvent(\MairieGestion\PlanningBundle\Entity\Event $events)
    {
        $this->events->removeElement($events);
    }

    /**
     * Get events
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getEvents()
    {
        return $this->events;
    }

    /**
     * Set couleurMenu
     *
     * @param string $couleurMenu
     * @return Mairie
     */
    public function setCouleurMenu($couleurMenu)
    {
        $this->couleurMenu = $couleurMenu;
    
        return $this;
    }

    /**
     * Get couleurMenu
     *
     * @return string 
     */
    public function getCouleurMenu()
    {
        return $this->couleurMenu;
    }

    /**
     * Set couleurTexteMenu
     *
     * @param string $couleurTexteMenu
     * @return Mairie
     */
    public function setCouleurTexteMenu($couleurTexteMenu)
    {
        $this->couleurTexteMenu = $couleurTexteMenu;
    
        return $this;
    }

    /**
     * Get couleurTexteMenu
     *
     * @return string 
     */
    public function getCouleurTexteMenu()
    {
        return $this->couleurTexteMenu;
    }

    /**
     * Set couleurOmbreTexteMenu
     *
     * @param string $couleurOmbreTexteMenu
     * @return Mairie
     */
    public function setCouleurOmbreTexteMenu($couleurOmbreTexteMenu)
    {
        $this->couleurOmbreTexteMenu = $couleurOmbreTexteMenu;
    
        return $this;
    }

    /**
     * Get couleurOmbreTexteMenu
     *
     * @return string 
     */
    public function getCouleurOmbreTexteMenu()
    {
        return $this->couleurOmbreTexteMenu;
    }

    /**
     * Set ombreTexteMenu
     *
     * @param boolean $ombreTexteMenu
     * @return Mairie
     */
    public function setOmbreTexteMenu($ombreTexteMenu)
    {
        $this->ombreTexteMenu = $ombreTexteMenu;
    
        return $this;
    }

    /**
     * Get ombreTexteMenu
     *
     * @return boolean 
     */
    public function getOmbreTexteMenu()
    {
        return $this->ombreTexteMenu;
    }

    /**
     * Set couleurHoverTexteMenu
     *
     * @param string $couleurHoverTexteMenu
     * @return Mairie
     */
    public function setCouleurHoverTexteMenu($couleurHoverTexteMenu)
    {
        $this->couleurHoverTexteMenu = $couleurHoverTexteMenu;
    
        return $this;
    }

    /**
     * Get couleurHoverTexteMenu
     *
     * @return string 
     */
    public function getCouleurHoverTexteMenu()
    {
        return $this->couleurHoverTexteMenu;
    }

    /**
     * Set hoverTexteMenu
     *
     * @param string $hoverTexteMenu
     * @return Mairie
     */
    public function setHoverTexteMenu($hoverTexteMenu)
    {
        $this->hoverTexteMenu = $hoverTexteMenu;
    
        return $this;
    }

    /**
     * Get hoverTexteMenu
     *
     * @return string 
     */
    public function getHoverTexteMenu()
    {
        return $this->hoverTexteMenu;
    }

    /**
     * Set couleurHoverBackgroundMenu
     *
     * @param string $couleurHoverBackgroundMenu
     * @return Mairie
     */
    public function setCouleurHoverBackgroundMenu($couleurHoverBackgroundMenu)
    {
        $this->couleurHoverBackgroundMenu = $couleurHoverBackgroundMenu;
    
        return $this;
    }

    /**
     * Get couleurHoverBackgroundMenu
     *
     * @return string 
     */
    public function getCouleurHoverBackgroundMenu()
    {
        return $this->couleurHoverBackgroundMenu;
    }

    /**
     * Set hoverBackgroundMenu
     *
     * @param boolean $hoverBackgroundMenu
     * @return Mairie
     */
    public function setHoverBackgroundMenu($hoverBackgroundMenu)
    {
        $this->hoverBackgroundMenu = $hoverBackgroundMenu;
    
        return $this;
    }

    /**
     * Get hoverBackgroundMenu
     *
     * @return boolean 
     */
    public function getHoverBackgroundMenu()
    {
        return $this->hoverBackgroundMenu;
    }

    /**
     * Set ongletActifMenu
     *
     * @param boolean $ongletActifMenu
     * @return Mairie
     */
    public function setOngletActifMenu($ongletActifMenu)
    {
        $this->ongletActifMenu = $ongletActifMenu;
    
        return $this;
    }

    /**
     * Get ongletActifMenu
     *
     * @return boolean 
     */
    public function getOngletActifMenu()
    {
        return $this->ongletActifMenu;
    }

    /**
     * Set couleurSousMenu
     *
     * @param string $couleurSousMenu
     * @return Mairie
     */
    public function setCouleurSousMenu($couleurSousMenu)
    {
        $this->couleurSousMenu = $couleurSousMenu;
    
        return $this;
    }

    /**
     * Get couleurSousMenu
     *
     * @return string 
     */
    public function getCouleurSousMenu()
    {
        return $this->couleurSousMenu;
    }

    /**
     * Set couleurTexteSousMenu
     *
     * @param string $couleurTexteSousMenu
     * @return Mairie
     */
    public function setCouleurTexteSousMenu($couleurTexteSousMenu)
    {
        $this->couleurTexteSousMenu = $couleurTexteSousMenu;
    
        return $this;
    }

    /**
     * Get couleurTexteSousMenu
     *
     * @return string 
     */
    public function getCouleurTexteSousMenu()
    {
        return $this->couleurTexteSousMenu;
    }

    /**
     * Set couleurOmbreTexteSousMenu
     *
     * @param string $couleurOmbreTexteSousMenu
     * @return Mairie
     */
    public function setCouleurOmbreTexteSousMenu($couleurOmbreTexteSousMenu)
    {
        $this->couleurOmbreTexteSousMenu = $couleurOmbreTexteSousMenu;
    
        return $this;
    }

    /**
     * Get couleurOmbreTexteSousMenu
     *
     * @return string 
     */
    public function getCouleurOmbreTexteSousMenu()
    {
        return $this->couleurOmbreTexteSousMenu;
    }

    /**
     * Set ombreTexteSousMenu
     *
     * @param boolean $ombreTexteSousMenu
     * @return Mairie
     */
    public function setOmbreTexteSousMenu($ombreTexteSousMenu)
    {
        $this->ombreTexteSousMenu = $ombreTexteSousMenu;
    
        return $this;
    }

    /**
     * Get ombreTexteSousMenu
     *
     * @return boolean 
     */
    public function getOmbreTexteSousMenu()
    {
        return $this->ombreTexteSousMenu;
    }

    /**
     * Set couleurHoverTexteSousMenu
     *
     * @param string $couleurHoverTexteSousMenu
     * @return Mairie
     */
    public function setCouleurHoverTexteSousMenu($couleurHoverTexteSousMenu)
    {
        $this->couleurHoverTexteSousMenu = $couleurHoverTexteSousMenu;
    
        return $this;
    }

    /**
     * Get couleurHoverTexteSousMenu
     *
     * @return string 
     */
    public function getCouleurHoverTexteSousMenu()
    {
        return $this->couleurHoverTexteSousMenu;
    }

    /**
     * Set hoverTexteSousMenu
     *
     * @param boolean $hoverTexteSousMenu
     * @return Mairie
     */
    public function setHoverTexteSousMenu($hoverTexteSousMenu)
    {
        $this->hoverTexteSousMenu = $hoverTexteSousMenu;
    
        return $this;
    }

    /**
     * Get hoverTexteSousMenu
     *
     * @return boolean 
     */
    public function getHoverTexteSousMenu()
    {
        return $this->hoverTexteSousMenu;
    }

    /**
     * Set couleurHoverBackgroundSousMenu
     *
     * @param string $couleurHoverBackgroundSousMenu
     * @return Mairie
     */
    public function setCouleurHoverBackgroundSousMenu($couleurHoverBackgroundSousMenu)
    {
        $this->couleurHoverBackgroundSousMenu = $couleurHoverBackgroundSousMenu;
    
        return $this;
    }

    /**
     * Get couleurHoverBackgroundSousMenu
     *
     * @return string 
     */
    public function getCouleurHoverBackgroundSousMenu()
    {
        return $this->couleurHoverBackgroundSousMenu;
    }

    /**
     * Set hoverBackgroundSousMenu
     *
     * @param boolean $hoverBackgroundSousMenu
     * @return Mairie
     */
    public function setHoverBackgroundSousMenu($hoverBackgroundSousMenu)
    {
        $this->hoverBackgroundSousMenu = $hoverBackgroundSousMenu;
    
        return $this;
    }

    /**
     * Get hoverBackgroundSousMenu
     *
     * @return boolean 
     */
    public function getHoverBackgroundSousMenu()
    {
        return $this->hoverBackgroundSousMenu;
    }

    /**
     * Set couleurBackground
     *
     * @param string $couleurBackground
     * @return Mairie
     */
    public function setCouleurBackground($couleurBackground)
    {
        $this->couleurBackground = $couleurBackground;
    
        return $this;
    }

    /**
     * Get couleurBackground
     *
     * @return string 
     */
    public function getCouleurBackground()
    {
        return $this->couleurBackground;
    }

    /**
     * Set patternBackground
     *
     * @param string $patternBackground
     * @return Mairie
     */
    public function setPatternBackground($patternBackground)
    {
        $this->patternBackground = $patternBackground;
    
        return $this;
    }

    /**
     * Get patternBackground
     *
     * @return string 
     */
    public function getPatternBackground()
    {
        return $this->patternBackground;
    }

    /**
     * Set intensityBackground 
     *
     * @param string $intensityBackground
     * @return Mairie
     */
    public function setIntensityBackground($intensityBackground)
    {
        $this->intensityBackground = $intensityBackground;
    
        return $this;
    }

    /**
     * Get intensityBackground
     *
     * @return string 
     */
    public function getIntensityBackground()
    {
        return $this->intensityBackground;
    }

    /**
     * Set backgroundPage
     *
     * @param boolean $backgroundPage
     * @return Mairie
     */
    public function setBackgroundPage($backgroundPage)
    {
        $this->backgroundPage = $backgroundPage;
    
        return $this;
    }

    /**
     * Get backgroundPage
     *
     * @return boolean 
     */
    public function getBackgroundPage()
    {
        return $this->backgroundPage;
    }

    /**
     * Set couleurBackgroundPage
     *
     * @param string $couleurBackgroundPage
     * @return Mairie
     */
    public function setCouleurBackgroundPage($couleurBackgroundPage)
    {
        $this->couleurBackgroundPage = $couleurBackgroundPage;
    
        return $this;
    }

    /**
     * Get couleurBackgroundPage
     *
     * @return string 
     */
    public function getCouleurBackgroundPage()
    {
        return $this->couleurBackgroundPage;
    }
    
    public function getCouleurBackgroundPageRgba()
    {
        return 'rgba('.hexdec(substr($this->couleurBackgroundPage,1,2)).', '.hexdec(substr($this->couleurBackgroundPage,3,2)).', '.hexdec(substr($this->couleurBackgroundPage,5,2)).', '.($this->intensityBackgroundPage/100).')';
    }

    /**
     * Set intensityBackgroundPage
     *
     * @param integer $intensityBackgroundPage
     * @return Mairie
     */
    public function setIntensityBackgroundPage($intensityBackgroundPage)
    {
        $this->intensityBackgroundPage = $intensityBackgroundPage;
    
        return $this;
    }

    /**
     * Get intensityBackgroundPage
     *
     * @return integer 
     */
    public function getIntensityBackgroundPage()
    {
        return $this->intensityBackgroundPage;
    }

    /**
     * Set nbHabitant
     *
     * @param integer $nbHabitant
     * @return Mairie
     */
    public function setNbHabitant($nbHabitant)
    {
        $this->nbHabitant = $nbHabitant;
    
        return $this;
    }

    /**
     * Get nbHabitant
     *
     * @return integer 
     */
    public function getNbHabitant()
    {
        return $this->nbHabitant;
    }

    /**
     * Set displayNbHabitant
     *
     * @param boolean $displayNbHabitant
     * @return Mairie
     */
    public function setDisplayNbHabitant($displayNbHabitant)
    {
        $this->displayNbHabitant = $displayNbHabitant;
    
        return $this;
    }

    /**
     * Get displayNbHabitant
     *
     * @return boolean 
     */
    public function getDisplayNbHabitant()
    {
        return $this->displayNbHabitant;
    }
}