<?php

namespace MairieGestion\MairieBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

use Symfony\Component\Validator\Constraints\NotBlank;
use Symfony\Component\Validator\Constraints\Email;

use MairieGestion\MainBundle\Form\AdresseType;
use MairieGestion\MainBundle\Entity\Adresse;

class MairieType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('name', 'text', array(
                'label' => 'Nom de la mairie',
                'mapped' => false,
                'constraints' => array(
            		new NotBlank(array(
            			'message' => 'Veuillez saisir le nom de la mairie',
            		)),
            	),
            ))
            ->add('domaine', 'text', array(
                'label' => 'Domaine',
                'attr' => array('placeholder'=>'www.domaine.com'),
                'mapped' => false,
                'constraints' => array(
            		new NotBlank(array(
            			'message' => 'Veuillez saisir le domaine de la mairie (ex: www.mondomaine.com)',
            		)),
            	),
            ))
            ->add('email', 'email',array(
                'label'=>'Email',
                'mapped' => false,
                'constraints' => array(
            		new NotBlank(array(
            			'message' => 'Veuillez saisir l\'adresse email du compte admin de la mairie',
            		)),
                    new Email(array(
            		)),
            	),
            ))
            ->add('password', 'password',array(
                'label'=>'Mot de passe',
                'mapped' => false,
                'constraints' => array(
            		new NotBlank(array(
            			'message' => 'Veuillez saisir le mot de passe du compte admin de la mairie',
            		)),
            	),
            ))
            ->add('Valider', 'submit',array(
                'attr'=> array('class'=>'btn', 'formnovalidate'=>true)
            ))
        ;
    }

    public function getName()
    {
        return 'mairietype';
    }
    
    // public function getDefaultOptions(array $options)
    // {
        // return array(
            // 'data_class' => 'MairieGestion\MairieBundle\Entity\Mairie',
        // );
    // }
}
