<?php

namespace MairieGestion\PageBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * ArchiveCategory
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="MairieGestion\PageBundle\Entity\ArchiveCategoryRepository")
 */
class ArchiveCategory
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=255)
     */
    private $name;
    
    /**
     * @var string
     *
     * @ORM\Column(name="key", type="string", length=255)
     */
    private $key;

    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\Archive", mappedBy="category")
     */
    private $archives;
    
    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return ArchiveCategory
     */
    public function setName($name)
    {
        $this->name = $name;
    
        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->archives = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Set key
     *
     * @param string $key
     * @return ArchiveCategory
     */
    public function setKey($key)
    {
        $this->key = $key;
    
        return $this;
    }

    /**
     * Get key
     *
     * @return string 
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * Add archives
     *
     * @param \MairieGestion\PageBundle\Entity\Archive $archives
     * @return ArchiveCategory
     */
    public function addArchive(\MairieGestion\PageBundle\Entity\Archive $archives)
    {
        $this->archives[] = $archives;
    
        return $this;
    }

    /**
     * Remove archives
     *
     * @param \MairieGestion\PageBundle\Entity\Archive $archives
     */
    public function removeArchive(\MairieGestion\PageBundle\Entity\Archive $archives)
    {
        $this->archives->removeElement($archives);
    }

    /**
     * Get archives
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getArchives()
    {
        return $this->archives;
    }
}