<?php

namespace MairieGestion\PageBundle\Entity;

use Doctrine\ORM\EntityRepository;
use MairieGestion\PageBundle\Entity\Config;
use Doctrine\ORM\Query;

/**
 * ConfigRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ConfigRepository extends EntityRepository
{
    public function getReseauxSociauxConfigsByMairie($mairie)
    {
        $qb = $this->createQueryBuilder('c');
        $qb->where('c.mairie = :mairie')
	    ->andWhere('c.name LIKE :category_name')
        ;
	
        $result = $qb->getQuery()->setParameters(array(
		'mairie' => $mairie,
		'category_name' => Config::CATEGORY_NAME_FACEBOOK.'%'
	))->getResult(Query::HYDRATE_ARRAY);
	
	if (count($result) == 0) {
	    $config = new Config();
	    $config->setMairie($mairie);
	    $config->setName('facebook_enabled');
	    $config->setValue('0');
	    $this->_em->persist($config);
	    
	    $config = new Config();
	    $config->setMairie($mairie);
	    $config->setName('facebook_height');
	    $config->setValue('');
	    $this->_em->persist($config);
	    
	    $config = new Config();
	    $config->setMairie($mairie);
	    $config->setName('facebook_page_url');
	    $config->setValue('');
	    $this->_em->persist($config);
	    
	    $config = new Config();
	    $config->setMairie($mairie);
	    $config->setName('facebook_show_friends_faces');
	    $config->setValue('0');
	    $this->_em->persist($config);
	    
	    $config = new Config();
	    $config->setMairie($mairie);
	    $config->setName('facebook_small_header');
	    $config->setValue('0');
	    $this->_em->persist($config);
	    
	    $config = new Config();
	    $config->setMairie($mairie);
	    $config->setName('facebook_hide_cover_photo');
	    $config->setValue('0');
	    $this->_em->persist($config);
	    
	    $config = new Config();
	    $config->setMairie($mairie);
	    $config->setName('facebook_show_page_posts');
	    $config->setValue('0');
	    $this->_em->persist($config);
	    
	    $this->_em->flush();
	    
	    $result = $qb->getQuery()->setParameters(array(
		'mairie' => $mairie,
	        'category_name' => Config::CATEGORY_NAME_FACEBOOK.'%'
	    ))->getResult(Query::HYDRATE_ARRAY);
	}
	
	$configs = array();
	
	foreach ($result as $config) {
		$configs[$config['name']] = $config['value'];
	}
	
	return $configs;
    }
}
