<?php

namespace MairieGestion\PageBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * ConseilMembreStatut
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="MairieGestion\PageBundle\Entity\ConseilMembreStatutRepository")
 */
class ConseilMembreStatut
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=255)
     */
    private $name;
    
    /**
     * @var string
     *
     * @ORM\Column(name="feminin_name", type="string", length=255)
     */
    private $femininName;
    
    /**
     * @var string
     *
     * @ORM\Column(name="maj_name", type="string", length=255)
     */
    private $majName;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="position", type="integer", nullable=true)
     */
    private $position;

    /**
     * @ORM\OneToMany(targetEntity="MairieGestion\PageBundle\Entity\ConseilMembre", mappedBy="statut", cascade={"persist", "remove"})
     * @ORM\OrderBy({"position" = "ASC"})
     */
    private $membres;

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return ConseilMembreStatut
     */
    public function setName($name)
    {
        $this->name = $name;
    
        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->membres = new \Doctrine\Common\Collections\ArrayCollection();
    }
    
    /**
     * Add membres
     *
     * @param \MairieGestion\PageBundle\Entity\ConseilMembre $membres
     * @return ConseilMembreStatut
     */
    public function addMembre(\MairieGestion\PageBundle\Entity\ConseilMembre $membres)
    {
        $this->membres[] = $membres;
    
        return $this;
    }

    /**
     * Remove membres
     *
     * @param \MairieGestion\PageBundle\Entity\ConseilMembre $membres
     */
    public function removeMembre(\MairieGestion\PageBundle\Entity\ConseilMembre $membres)
    {
        $this->membres->removeElement($membres);
    }

    /**
     * Get membres
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getMembres()
    {
        return $this->membres;
    }

    /**
     * Set position
     *
     * @param integer $position
     * @return ConseilMembreStatut
     */
    public function setPosition($position)
    {
        $this->position = $position;
    
        return $this;
    }

    /**
     * Get position
     *
     * @return integer 
     */
    public function getPosition()
    {
        return $this->position;
    }

    /**
     * Set majName
     *
     * @param string $majName
     * @return ConseilMembreStatut
     */
    public function setMajName($majName)
    {
        $this->majName = $majName;
    
        return $this;
    }

    /**
     * Get majName
     *
     * @return string 
     */
    public function getMajName()
    {
        return $this->majName;
    }

    /**
     * Set femininName
     *
     * @param string $femininName
     * @return ConseilMembreStatut
     */
    public function setFemininName($femininName)
    {
        $this->femininName = $femininName;
    
        return $this;
    }

    /**
     * Get femininName
     *
     * @return string 
     */
    public function getFemininName()
    {
        return $this->femininName;
    }
}