<?php

namespace MairieGestion\PageBundle\Entity;

use Doctrine\ORM\EntityRepository;

/**
 * PageRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class PageRepository extends EntityRepository
{
    public function getAgendaPage($mairie)
    {
        $qb = $this->createQueryBuilder('p');
        $qb
            ->andWhere('p.mairie = :mairie')
            ->andWhere('p.online = 1')
            ->leftJoin('p.type', 't')
            ->andWhere('t.id = 10')
        ;
        $result = $qb->getQuery()->setParameter('mairie',$mairie)->getResult();
        if (isset($result[0]))
            return $result[0];
        return $result;
    }
    public function getPageByPath($mairie,$path)
    {
        $qb = $this->createQueryBuilder('p');
        $qb
            ->andWhere('p.mairie = :mairie')
            ->andWhere('p.path = :path OR (p.path IS NULL and p.pathAuto = :path)')
        ;
        return $qb->getQuery()->setParameter('mairie',$mairie)->setParameter('path',$path)->getResult();
    }
    public function getPagesFilter($mairie,$filter='tous',$master_only=false,$first_level_only=false)
    {
        $qb = $this->createQueryBuilder('p');
        if ($filter == 'online')
            $qb->andWhere('p.online = 1');
        elseif ($filter == 'offline')
            $qb->andWhere('p.online = 0');
        $qb
            ->andWhere('p.mairie = :mairie')
            ->orderBy('p.position','ASC')
            ;
        if ($master_only)
            $qb->andWhere('p.parent is NULL');
        elseif($first_level_only)
            $qb
                ->join('p.parent', 'pa')
                ->andWhere('pa.parent is NULL')
            ;
        return $qb->getQuery()->setParameter('mairie',$mairie)->getResult();
    }
    public function getPagesMasterFilter($mairie,$filter='tous')
    {
        return $this->getPagesFilter($mairie,$filter,true);
    }
    public function getPagesFirstLevel($mairie,$filter='tous')
    {
        return $this->getPagesFilter($mairie,$filter,false,true);
    }
    private function _pushPageRecursive(&$tab, $pages,$page_origin=null)
    {
        foreach($pages as $page)
        {
            if (!$page_origin || ($page_origin->getId() != $page->getId()))
                $tab[] = $page;
            if ($page->getChildren())
                $this->_pushPageRecursive($tab,$page->getChildren(),$page_origin);
        }
    }
    public function getPotentialPages($mairie,$page)
    {
        $tab = array();
        $pages = $this->getPagesMasterFilter($mairie);
        $this->_pushPageRecursive($tab,$pages,$page);
        return $tab;
    }
}
