<?php

namespace MairieGestion\PageBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

use MairieGestion\MainBundle\Form\AdresseType;
use MairieGestion\MainBundle\Entity\Adresse;

class ApparenceParamType extends AbstractType
{
	private $obj;
    
    public function __construct($obj,$em)
    {
        $this->obj = $obj;
        $this->em = $em;
    }
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        // $pages = $this->em->getRepository('MairieGestionPageBundle:Page')->getPotentialPages($this->mairie, $this->obj);
        
        $builder
            ->add('couleurMenu', 'text', array(
                'label' => 'Couleur du menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurTexteMenu', 'text', array(
                'label' => 'Couleur du texte du menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('ombreTexteMenu', 'checkbox', array(
                'label' => 'Ombre sur le texte du menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurOmbreTexteMenu', 'text', array(
                'label' => 'Couleur de l\'ombre du texte du menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('hoverTexteMenu', 'checkbox', array(
                'label' => 'Texte du menu au passage de la souris',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurHoverTexteMenu', 'text', array(
                'label' => 'Couleur de l\'hover du texte du menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('hoverBackgroundMenu', 'checkbox', array(
                'label' => 'Fond du menu au passage de la souris',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurHoverBackgroundMenu', 'text', array(
                'label' => 'Couleur de l\'hover du fond du menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            
            ->add('couleurSousMenu', 'text', array(
                'label' => 'Couleur du sous-menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurTexteSousMenu', 'text', array(
                'label' => 'Couleur du texte du sous-menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('ombreTexteSousMenu', 'checkbox', array(
                'label' => 'Ombre sur le texte du sous-menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurOmbreTexteSousMenu', 'text', array(
                'label' => 'Couleur de l\'ombre du texte du sous-menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('hoverTexteSousMenu', 'checkbox', array(
                'label' => 'Texte du sous-menu au passage de la souris',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurHoverTexteSousMenu', 'text', array(
                'label' => 'Couleur de l\'hover du texte du sous-menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('hoverBackgroundSousMenu', 'checkbox', array(
                'label' => 'Fond du sous-menu au passage de la souris',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurHoverBackgroundSousMenu', 'text', array(
                'label' => 'Couleur de l\'hover du fond du sous-menu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            
            ->add('couleurBackground', 'text', array(
                'label' => 'Couleur du fond d\'écran',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('patternBackground', 'entity', array(
                'label' => 'Motif du fond d\'écran',
                'class' => 'MairieGestionPageBundle:PatternBackground',
                'property' => 'name',
            ))
            ->add('intensityBackground', 'text', array(
                'label' => 'Intensité du motif du fond d\'écran',
            ))
            
            ->add('backgroundPage', 'checkbox', array(
                'label' => 'Mettre un fond de contenu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('couleurBackgroundPage', 'text', array(
                'label' => 'Couleur du fond de contenu',
                'label_attr' => array(
                    'class' => 'label_color',
                ),
            ))
            ->add('intensityBackgroundPage', 'text', array(
                'label' => 'Intensité du motif du fond de contenu',
            ))
            ->add('Valider', 'submit',array(
                'attr'=> array('class'=>'btn', 'formnovalidate'=>true)
            ))
        ;
    }

    public function getName()
    {
        return 'apparencetype';
    }
    
    public function getDefaultOptions(array $options)
    {
        return array(
            'data_class' => 'MairieGestion\MairieBundle\Entity\Mairie',
        );
    }
}
