<?php

namespace MairieGestion\PageBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class ArchiveType extends AbstractType
{
    public function __construct()
    {
    }
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('name', 'text', array('label' => 'Titre de l\'archive','attr' => array('class'=>'form-control')))
            ->add('date','date',array(
                'label' => 'Date',
                'widget' => 'single_text',
                'format' => 'dd/MM/yyyy',
                'attr' => array(
                    'class' => 'form-control date',
                ),
            ))
            ->add('description', 'textarea', array(
                'label' => 'Description',
                'attr' => array('class'=>'form-control')
            ))
            ->add('active', 'checkbox', array(
                'label' => 'Activé',
                'data' => true,
                'label_attr'=>array('style'=>'display:inline-block'),
            ))
            ->add('Valider', 'submit',array(
                'attr'=> array('class'=>'btn', 'formnovalidate'=>true)
            ))
        ;
    }

    public function getName()
    {
        return 'archivetype';
    }
    
    public function getDefaultOptions(array $options)
    {
        return array(
            'data_class' => 'MairieGestion\PageBundle\Entity\Archive',
        );
    }
}
