<?php

namespace MairieGestion\PageBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class ConseilMembreType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $choices = array();
        for ($i=1;$i<=11;$i++)
        {
            if ($i == 1)
                $choices[$i] = $i.'er';
            else
                $choices[$i] = $i.'ème';
        }
        $builder
            ->add('numAdjoint', 'choice', array(
                'choices'   => $choices,
                'attr' => array('style'=>'width:100px'),
            ))
            ->add('statut', 'entity', array(
                'class' => 'MairieGestionPageBundle:ConseilMembreStatut',
                'property' => 'majName',
                'attr' => array('class'=>'form-control'),
            ))
            ->add('civilite', 'entity', array(
                'class' => 'MairieGestionMainBundle:Civilite',
                'property' => 'name',
                'attr' => array('class'=>'form-control'),
            ))
            ->add('nom', 'text', array('label' => 'Nom','attr' => array('class'=>'form-control')))
            ->add('prenom', 'text', array('label' => 'Prénom','attr' => array('class'=>'form-control')))
            ->add('telFixe', 'text', array('label' => 'Tel fixe','attr' => array('class'=>'form-control')))
            ->add('adresse1', 'text', array('label' => 'Adresse 1','attr' => array('class'=>'form-control')))
            ->add('adresse2', 'text', array('label' => 'Adresse 2','attr' => array('class'=>'form-control')))
            ->add('adresse3', 'text', array('label' => 'Adresse 3','attr' => array('class'=>'form-control')))
            ->add('cp', 'text', array('label' => 'Code postal','attr' => array('class'=>'form-control')))
            ->add('ville', 'text', array('label' => 'Ville','attr' => array('class'=>'form-control')))
            ->add('telFixe', 'text', array('label' => 'Tel fixe','attr' => array('class'=>'form-control')))
            ->add('telPortable', 'text', array('label' => 'Tel portable','attr' => array('class'=>'form-control')))
            ->add('fax', 'text', array('label' => 'Fax','attr' => array('class'=>'form-control')))
            ->add('email', 'email', array('label' => 'Email','attr' => array('class'=>'form-control')))
            ->add('dateNaissance','date',array(
                'label' => 'Date de naissance',
                'widget' => 'single_text',
                'format' => 'dd/MM/yyyy',
                'attr' => array('class'=>'form-control date'),
            ))
            ->add('description', 'textarea', array('label' => 'Description','attr' => array('class'=>'form-control')))
            ->add('Valider', 'submit',array(
                'attr'=> array('class'=>'btn', 'formnovalidate'=>true)
            ))
        ;
    }

    public function getName()
    {
        return 'conseilmembretype';
    }
    
    public function getDefaultOptions(array $options)
    {
        return array(
            'data_class' => 'MairieGestion\PageBundle\Entity\ConseilMembre',
        );
    }
}
