<?php

namespace MairieGestion\PageBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class LieuType extends AbstractType
{
    private $obj;
    
    public function __construct($obj)
    {
        $this->obj = $obj;
    }
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('name', 'text', array('label' => 'Titre du lieu','attr' => array('class'=>'form-control')))
            ->add('adresse1', 'text', array('label' => 'Adresse1','attr' => array('class'=>'form-control')))
            ->add('adresse2', 'text', array('label' => 'Adresse2','attr' => array('class'=>'form-control')))
            ->add('cp', 'text', array('label' => 'Code postal','attr' => array('class'=>'form-control')))
            ->add('ville', 'text', array('label' => 'Ville','attr' => array('class'=>'form-control')))
            ->add('telFixe', 'text', array('label' => 'Tel fixe','attr' => array('class'=>'form-control')))
            ->add('telPortable', 'text', array('label' => 'Tel portable','attr' => array('class'=>'form-control')))
            ->add('email', 'email', array('label' => 'Email','attr' => array('class'=>'form-control')))
            ->add('siteInternet', 'text', array('label' => 'Site internet','attr' => array('class'=>'form-control')))
            ->add('description', 'textarea', array('label' => 'Description','attr' => array('class'=>'form-control')))
            ->add('latitude', 'text', array('label' => 'Latitude','attr' => array('class'=>'form-control')))
            ->add('longitude', 'text', array('label' => 'Longitude','attr' => array('class'=>'form-control')))
            ->add(($this->obj->getId()?'Modifier':'Ajouter').' ce lieu', 'submit',array(
                'attr'=> array('class'=>'btn', 'formnovalidate'=>true)
            ))
        ;
    }

    public function getName()
    {
        return 'lieutype';
    }
    
    public function getDefaultOptions(array $options)
    {
        return array(
            'data_class' => 'MairieGestion\PageBundle\Entity\Lieu',
        );
    }
}
