<?php

namespace MairieGestion\PageBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

use MairieGestion\MainBundle\Form\AdresseType;
use MairieGestion\MainBundle\Entity\Adresse;

class ReseauxSociauxType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('facebook_enabled', 'checkbox', array(
                'label' => 'Activer Facebook ?',
		'required' => false
            ))
            ->add('facebook_height', 'text', array(
                'label' => 'Hauteur du bloc',
		'required' => false
            ))
            ->add('facebook_page_url', 'text', array(
                'label'=> 'Url de la page Facebook',
                'attr' => array('class' => 'form-control'),
		'required' => false
            ))
            ->add('facebook_show_friends_faces', 'checkbox', array(
                'label' => 'Afficher la photo de ses amis',
		'required' => false
            ))
            ->add('facebook_small_header', 'checkbox', array(
                'label'=> 'Petite bannière',
		'required' => false
            ))
            ->add('facebook_hide_cover_photo', 'checkbox', array(
                'label'=> 'Ne pas afficher de bannière',
		'required' => false
            ))
            ->add('facebook_show_page_posts', 'checkbox', array(
                'label'=> 'Afficher les messages de la page Facebook',
		'required' => false
            ))
            ->add('Valider', 'submit', array(
                'attr'=> array(
		    'class' => 'btn', 
		    'formnovalidate' => true
		)
            ))
        ;
    }

    public function getName()
    {
        return 'reseaux_sociaux_type';
    }
}
