<?php

namespace MairieGestion\PageBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

use MairieGestion\MainBundle\Form\AdresseType;
use MairieGestion\MainBundle\Entity\Adresse;

class SiteParamType extends AbstractType
{
	private $obj;
    
    public function __construct($obj,$em)
    {
        $this->obj = $obj;
        $this->em = $em;
    }
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        // $pages = $this->em->getRepository('MairieGestionPageBundle:Page')->getPotentialPages($this->mairie, $this->obj);
        
        $builder
            ->add('name', 'text', array(
                'label' => 'Nom de la mairie',
                'attr' => array('class'=>'form-control'),
            ))
            ->add('email', 'email',array(
                'label'=>'Email',
                'attr' => array('class'=>'form-control'),
            ))
            ->add('adresse', new AdresseType($this->obj->getAdresse()), array(
                'label' => ' ',
            ))
            ->add('tel', 'text',array(
                'label'=>'Téléphone',
                'attr' => array('class'=>'form-control'),
            ))
            ->add('fax', 'text',array(
                'label'=>'Fax',
                'attr' => array('class'=>'form-control'),
            ))
            ->add('displayNbHabitant', 'checkbox',array(
                'label'=>'Afficher le nombre d\'habitants',
            ))
            ->add('nbHabitant', 'text',array(
                'label'=>'Nombre d\'habitants',
                'attr' => array('class'=>'form-control'),
            ))
            ->add('horaire', 'textarea',array(
                'label'=>'Horaires d\'ouverture',
                'attr'=>array('class'=>'wiziwig')
            ))
            ->add('description', 'textarea',array(
                'label'=>'Texte de présentation',
                'attr'=>array('class'=>'wiziwig')
            ))
            ->add('Valider', 'submit',array(
                'attr'=> array('class'=>'btn', 'formnovalidate'=>true)
            ))
        ;
    }

    public function getName()
    {
        return 'siteparamtype';
    }
    
    public function getDefaultOptions(array $options)
    {
        return array(
            'data_class' => 'MairieGestion\PageBundle\Entity\Page',
        );
    }
}
