<?php

namespace MairieGestion\PlanningBundle\Entity;

use Doctrine\ORM\EntityRepository;

/**
 * EventRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class EventRepository extends EntityRepository
{
    public function getEventsHome($mairie)
    {
        $qb = $this->createQueryBuilder('e');
        $qb
            ->andWhere('e.public = 1')
            ->andWhere('e.home = 1')
            ->andWhere('e.active = 1')
            ->andWhere('e.mairie = :mairie')
            ->andWhere('e.dateBegin >= :now')
            ->orderBy('e.dateBegin','ASC')
            ->setMaxResults(5)
        ;
        $date = new \DateTime();
        $date->modify('today');
        return $qb->getQuery()->setParameter('mairie',$mairie)->setParameter('now',$date)->getResult();     
    }
    
    public function getEventsFront($mairie)
    {
        $qb = $this->createQueryBuilder('e');
        $qb
            ->andWhere('e.public = 1')
            ->andWhere('e.active = 1')
            ->andWhere('e.mairie = :mairie')
            ->orderBy('e.dateBegin','ASC')
        ;
        return $qb->getQuery()->setParameter('mairie',$mairie)->getResult();     
    }
    
    public function getEventsFilter($user,$filter)
    {
        $qb = $this->createQueryBuilder('e');
        if ($filter == 'actifs')
            $qb->andWhere('e.active = 1');
        elseif ($filter == 'inactifs')
            $qb->andWhere('e.active = 0');
        $qb
            ->leftJoin('e.user', 'u')
            ->andWhere('u.mairie = :mairie')
            ->orderBy('e.dateBegin','ASC')
            ;
        return $qb->getQuery()->setParameter('mairie',$user->getMairie())->getResult();     
    }
    
    public function getFormatedEventsSemaine($events,$year,$week)
    {
        // Si le 1er janvier tombe semaine 53 de l'année précédent on doit tenir compte d'une semaine en plus
        if (date('W',mktime(0,0,0,1,1,$year)) == 53)
            $week++;
        $startdate = strtotime('+'.($week-1).' week',mktime(0,0,0,1,1,$year));
        $monday = strtotime((date('N')==1?'this':'last').' monday', $startdate);
        $sunday = strtotime('this sunday', $startdate);
        $sunday = mktime(23,59,59,date('n',$sunday),date('j',$sunday),date('Y',$sunday));
        $return['data'] = array();
        for($i=0;$i<7;$i++)
            $return['data'][$i] = array();
        $return['events'] = array();
        foreach($events as $event)
        {
            $return['events'][$event->getId()] = $event;
            for($i=0;$i<7;$i++)
            {
                $day_current = strtotime('+'.$i.' day',$monday);
                $day_current_end = mktime(23,59,59,date('n',$day_current),date('j',$day_current),date('Y',$day_current));
                if ($event->getDateBegin()->getTimestamp() <= $day_current_end && $event->getDateEnd()->getTimestamp() >= $day_current)
                {
                    $return['data'][$i][$event->getId()] = array(
                        'begin' => $event->getDateBegin()->getTimestamp()<$day_current?0:intval(date('G',$event->getDateBegin()->getTimestamp()).(strlen(round(date('i',$event->getDateBegin()->getTimestamp())/60*100))<2?'0'.(round(date('i',$event->getDateBegin()->getTimestamp())/60*100)):(round(date('i',$event->getDateBegin()->getTimestamp())/60*100)))),
                        'end' => $event->getDateEnd()->getTimestamp()>mktime(23,59,59,date('n',$day_current),date('j',$day_current),date('Y',$day_current))?2400:intval(date('G',$event->getDateEnd()->getTimestamp()).(strlen(round(date('i',$event->getDateEnd()->getTimestamp())/60*100))<2?'0'.(round(date('i',$event->getDateEnd()->getTimestamp())/60*100)):(round(date('i',$event->getDateEnd()->getTimestamp())/60*100)))),
                    );
                }
            }
        }
        return $return;
    }
}
