<?php

namespace MairieGestion\PlanningBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use MairieGestion\MainBundle\Form\AdresseType;
use MairieGestion\MainBundle\Entity\Adresse;

class EventType extends AbstractType
{
	private $obj;
    
    public function __construct($obj)
    {
        $this->obj = $obj;
    }
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('title', 'text', array('label' => 'Titre','attr' => array('style'=>'width:300px','class'=>'form-control')))
            ->add('date_begin','datetime',array(
                'label' => 'Début',
                'date_widget' => 'single_text',
                'time_widget' => 'text',
                'date_format' => 'dd/MM/yyyy',
                'attr' => array(
                    'class' => 'date',
                ),
            ))
            ->add('date_end','datetime',array(
                'label' => 'Fin',
                'date_widget' => 'single_text',
                'time_widget' => 'text',
                'date_format' => 'dd/MM/yyyy',
                'attr' => array(
                    'class' => 'date',
                ),
            ))
            ->add('lieu', 'text', array(
                'label' => 'Lieu',
                'attr' => array('class'=>'form-control'),
            ))
            ->add('description', 'textarea', array('label' => 'Déscription','attr' => array('class'=>'form-control')))
            ->add('url', 'text', array(
                'label' => 'URL',
                'required' => false,
                'attr' => array('class'=>'form-control'),
            ))
            // ->add('category', 'entity', array(
            // 'class' => 'MairieGestionPlanningBundle:CategoryEvent',
            // 'property' => 'name',))
            // ->add(
                // $builder->create('adresse', 'form', array('label' => ' ','by_reference' => 'adresse'))
                    // ->add('rue', 'text',array('label'=>'Adresse'))
                    // ->add('cp', 'text',array('label'=>'Code postal'))
                    // ->add('city', 'text',array('label'=>'Ville'))
                    // ->add('tel_fixe', 'text',array('label'=>'Téléphone fixe'))
                    // ->add('tel_portable', 'text',array('label'=>'Téléphone portable'))
            // )
            // ->add('adresse', new AdresseType($this->obj->getAdresse()), array('label' => ' ','class' => 'MairieGestionMainBundle:Adresse',))
            // ->add('adresse', 'entity', array('class'         => 'MairieGestionMainBundle:Adresse'))
            ->add('public', 'choice', array('label' => 'Public',
                'required' => true,
                'expanded' => true,
                'multiple' => false,
                'choices' => array(0 => 'Privé', 1 => 'Public'),
                'attr' => array(
                    'class' => 'input_checkbox',
                ),
                'label_attr' => array(
                    'class' => 'label_checkbox',
                )
            ))
            ->add('home', 'checkbox', array(
                'label' => 'Afficher sur la page d\'accueil',
                'required' => false,
                'attr' => array(
                    'class' => 'input_checkbox',
                ),
                'label_attr' => array(
                    'class' => 'label_checkbox',
                )
            ))
            ->add('Valider', 'submit',array(
                'attr'=> array('class'=>'btn')
            ))
            ;
    }

    public function getName()
    {
        return 'eventtype';
    }
    
    public function getDefaultOptions(array $options)
    {
        return array(
            'data_class' => 'MairieGestion\PlanningBundle\Entity\Event',
        );
    }
}
