<?php

namespace MairieGestion\UserBundle\Form;

use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use MairieGestion\MainBundle\Form\AdresseType;
use MairieGestion\MainBundle\Entity\Adresse;

class UserType extends AbstractType
{
	private $obj;
    
    public function __construct($obj)
    {
        $this->obj = $obj;
    }
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('email', 'text', array('label' => 'Email'))
            ->add('first_name', 'text', array('label' => 'Prénom'))
            ->add('name', 'text', array('label' => 'Nom'))
            ->add('birthday','date',array(
                'label' => 'Date de naissance',
                'widget' => 'single_text',
                'format' => 'dd/MM/yyyy',
                'attr' => array('class' => 'date')
            ))
            ->add('sexe', 'choice', array(
                'label' => ' ',
                'choices'   => array(
                    '0'   => 'Homme',
                    '1' => 'Femme',
                ),
                'expanded'  => true,
                'attr' => array('class'=>'sexe'),
            ))
            ->add('tel_fixe', 'text',array('label'=>'Téléphone fixe'))
            ->add('tel_portable', 'text',array('label'=>'Téléphone portable'))
            ->add('adresse', new AdresseType($this->obj->getAdresse()), array('label' => ' ',))
        ;
        if (!$this->obj->getId())
            $builder->add('password', 'password', array('label' => 'Mot de passe'));
        $builder
            ->add('Valider', 'submit',array(
                'attr'=> array('class'=>'btn', 'formnovalidate'=>true)
            ))
            ;
    }

    public function getName()
    {
        return 'usertype';
    }
    
    public function getDefaultOptions(array $options)
    {
        return array(
            'data_class' => 'MairieGestion\UserBundle\Entity\User',
        );
    }
}
