var geocoder;
var map;
var infowindow = new google.maps.InfoWindow();
var marker = null;

function initialize() {
    var input = document.getElementById('address');
    var options = {
    };
    autocomplete = new google.maps.places.Autocomplete(input, options);  

    geocoder = new google.maps.Geocoder();
    
    //var latlng = new google.maps.LatLng(48.856614, 2.352221);
    var myOptions = {
      zoom: 14,
      mapTypeId: google.maps.MapTypeId.SATELLITE
    }
    map = new google.maps.Map(document.getElementById("carte_create_lieu"), myOptions);
    var address = document.getElementById("address").value;
    geocoder.geocode( { 'address': address}, function(results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
            map.setCenter(results[0].geometry.location);
        }
    });
    google.maps.event.addListener(map, 'click', codeLatLngfromclick);
    google.maps.event.addListener(map, 'zoom_changed', function() {
        var zoomLevel = map.getZoom();
        $('#linkzoom').fadeOut(500, function() {
            $(this).text(zoomLevel).fadeIn(500);
        });
    });
    google.maps.event.addListener(map, 'maptypeid_changed', function() {
        var type = map.getMapTypeId();
        $('#linktype').fadeOut(500, function() {
            $(this).text(type).fadeIn(500);
        });
    });
}

function codeAddress() {
    var address = document.getElementById("address").value;
    geocoder.geocode( { 'address': address}, function(results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
            map.setCenter(results[0].geometry.location);
            if (marker != null) marker.setMap(null);
            latres = results[0].geometry.location.lat();
            lngres = results[0].geometry.location.lng();

            infowindow.open(map, marker);
            document.getElementById("lieutype_latitude").value="";
            document.getElementById("lieutype_longitude").value="";
        } else {
            alert("Erreur de geocoding pour la raison suivante : " + status);
        }
    });
}

function codeLatLng() {
    var lat = parseFloat(document.getElementById("lieutype_latitude").value);
    var lng = parseFloat(document.getElementById("lieutype_longitude").value);
    var latlng = new google.maps.LatLng(lat, lng);
    geocoder.geocode({'latLng': latlng}, function(results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
            if (results[0]) {
                if (marker != null) marker.setMap(null);
                marker = new google.maps.Marker({
                    position: latlng,
                    map: map
                });
                infowindow.open(map, marker);
                document.getElementById("address").value=results[0].formatted_address;
            }
        } else {
            if (marker != null) marker.setMap(null);
            marker = new google.maps.Marker({
                position: latlng,
                map: map
            });
            infowindow.open(map, marker);
            document.getElementById("address").value='Pas d\'adresse correspondant à ces coordonnées GPS';
            alert("Erreur de geocoding pour la raison suivante : " + status);
        }
    });
    map.setCenter(latlng);
}

function codeLatLngfromclick(event) {
    var lat = event.latLng.lat();
    var lng = event.latLng.lng();
    var latlng = event.latLng;
    geocoder.geocode({'latLng': latlng}, function(results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
            if (results[0]) {
                if (marker != null) marker.setMap(null);
                marker = new google.maps.Marker({
                    position: latlng,
                    map: map
                });
                map.setCenter(latlng);
                infowindow.open(map, marker);
                document.getElementById("address").value=results[0].formatted_address;
                document.getElementById("lieutype_latitude").value=lat;
                document.getElementById("lieutype_longitude").value=lng;
            }
        } else {
            if (marker != null) marker.setMap(null);
            marker = new google.maps.Marker({
                position: latlng,
                map: map
            });
            map.setCenter(latlng);
            infowindow.open(map, marker);
            document.getElementById("address").value='Pas d\'adresse correspondant à ces coordonnées GPS';
            document.getElementById("lieutype_latitude").value=lat;
            document.getElementById("lieutype_longitude").value=lng;
            alert("Erreur de geocoding pour la raison suivante : " + status);
        }
    });
}      
$(document).ready(function() {
    initialize();
    $('#address').keypress(function(e) {
        //Enter key
        if (e.which == 13) {
          codeAddress();
          return false;
        }
    });
});