<?php
    require_once __DIR__.'/../bootstrap.php.cache';
    require_once __DIR__.'/../AppKernel.php';
    
    use Lizeo\PCPBundle\Utils\FileManipulation;
    use Lizeo\PCPBundle\Entity\TypeFile;
    use Lizeo\PCPBundle\Entity\File;
    
    $kernel = new \AppKernel("prod", false);
    $kernel->boot();
    $container = $kernel->getContainer();

    $url = $container->getParameter('excel_template_remote_directory_out');
    $ftp_username = $container->getParameter('qlikview_ftp_username');
    $ftp_password = $container->getParameter('qlikview_ftp_password');
    $ftp_cert_path = $container->getParameter('qlikview_ftp_cert_path');
    $excel_template_local_directory = $container->getParameter('excel_template_local_directory');

    /**
    * List remote server directory 
    */
    $datetime = date("YmdHis");
    $filename_verbose = $container->getParameter('excel_generator_log_dir').'listing-verbose-'.$datetime.'.log';
    $fp = fopen($filename_verbose, 'w');


    /** @var \Lizeo\PCPBundle\Service\SshConnector $sshConnector */
    $sshConnector = $container->get('pcp_ssh_connector');
    $sshConnector->initSession();
    try {
        $files = $sshConnector->getListByDirectory($url);
        $sshConnector->closeSession();
    }
    catch (Exception $e) {
        $log = new FileManipulation($container->getParameter('excel_generator_log_dir').'listing-'.$datetime.'.log', 'w');
        $log->write('[SSH Error] Unable to retrieve a list of Excel template from directory');
        $log->close();
        fclose($fp);
    }

    fclose($fp);
    unlink($filename_verbose);
    
    $fichiers = array();
    foreach($files as $fichier) {
        if(substr($fichier, 0, 2) == "CO") {
            $fichiers[] = $fichier;
        }
    }

    /**
    * Get files from remote server 
    */
    if (sizeof($fichiers) > 0) {
        $ch = null;
        $fp = null;

        foreach($fichiers as $fichier) {
            $fnp = new Lizeo\PCPBundle\Utils\FileNameParse($fichier);
            $directory = $excel_template_local_directory.$fnp->getYear().$fnp->getMonth()."/";

            if(!file_exists($directory)) {
                mkdir($directory);
            }

            /** @var \Lizeo\PCPBundle\Service\SshConnector $sshConnector */
            $sshConnector = $container->get('pcp_ssh_connector');
            $sshConnector->initSession();
            $isRetrieve = $sshConnector->getFileByScp($url.$fichier, $directory.$fichier);
            $sshConnector->closeSession();
        }
    }
