<?php

/**
 * php ReloadLastFile.php [COUNTRY] [PRODUCT_LINE] [SEASON] [YEAR] [MONTH]
 */

// Product line
$_productLine = array("TC" => array("TC"), "PL" => array("PL"), "ALL" => array("TC", "PL"));

// Season
$_season = array("SUMMER" => array("SUMMER"), "WINTER" => array("WINTER"), "ALL" => array("SUMMER", "WINTER"));

/**
 * Get parameters
 */
$countryCode = $argv[1];
$productLine = $argv[2];

if (!array_key_exists($productLine, $_productLine)) {
    die('You must use "TC", "PL" or "ALL" for product line.');
}

$season = $argv[3];

if (!array_key_exists($season, $_season)) {
    die('You must use "SUMMER", "WINTER" or "ALL" for season.');
}

$year = $argv[4];
$datePeriods = array();

if (isset($argv[5])) {
    $month = $argv[5];
    $datePeriods[] = $year.$month."01";
} else {
    for ($i=1;$i<=12;$i++) {
        if ($i < 10) {
            $datePeriods[] = $year."0".$i."01";
        } else {
            $datePeriods[] = $year.$i."01";
        }
    }
}

require_once __DIR__.'/../bootstrap.php.cache';
require_once __DIR__.'/../AppKernel.php';

$kernel = new \AppKernel("preprod", false);
$kernel->boot();
$container = $kernel->getContainer();
$doctrine = $container->get('doctrine');

// Get default user
$user = $doctrine->getRepository('LizeoUserBundle:User')->find($container->getParameter('default_user_id'));
$countries = array();

if ($countryCode == "ALL") {
    $countries = $doctrine->getRepository('LizeoPCPBundle:Country')->findAll(true, false);
} else {
    $country = $doctrine->getRepository('LizeoPCPBundle:Country')->findOneCountryByCode($countryCode);
    
    if (!is_null($country)) {
        $countries[] = $country;
    }
}

$manager = $container->get('pcp_manager');

foreach ($countries as $country) {
    foreach ($datePeriods as $datePeriod) {
        $manager->reloadLastFile($user, $country, $productLine, $season, $datePeriod);
    }
}
