<?php

namespace Lizeo\PCPBundle\Controller;

use Symfony\Bundle\TwigBundle\Controller\ExceptionController as BaseExceptionController;
use Symfony\Bundle\FrameworkBundle\Templating\TemplateReference;
use Symfony\Component\HttpKernel\Exception\FlattenException;
use Symfony\Component\HttpKernel\Log\DebugLoggerInterface;
use Symfony\Component\HttpFoundation\Response;

class ExceptionController extends BaseExceptionController
{
    public function showAction(FlattenException $exception, DebugLoggerInterface $logger = null, $format = 'html')
    {
        $kernel = $this->container->get('kernel');
        $request = $this->container->get('request');
        $request->setRequestFormat($format);

        $templating = $this->container->get('templating');
        $code = $exception->getStatusCode();

        $template = new TemplateReference('PCPBundle', 'Exception', 'error', $format, 'twig');

        if ($templating->exists($template)) {
                $response = $templating->renderResponse($template, array(
                    'status_code' => $code,
                    'message_code' => 'error_' . $code,
                    'status_text' => Response::$statusTexts[$code],
                    'requested_url' => $request->getUri(),
            ));

            $response->setStatusCode($code);
            $response->headers->replace($exception->getHeaders());

            return $response;
        }

        return parent::showAction($exception, $logger, $format);
    }
}
