<?php

namespace Lizeo\PCPBundle\Entity;

use Lizeo\PCPBundle\Model\Country as AbstractCountry;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="Lizeo\PCPBundle\Entity\Repository\CountryRepository")
 * @ORM\Table(name="sy_country")
 * @UniqueEntity("code")
 */
class Country extends AbstractCountry
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $name;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $code;
    
    /**
     *
     * @ORM\Column(type="boolean")
     */
    protected $is_all;
    
    /**
     *
     * @ORM\Column(type="integer")
     */
    protected $country_id;
    
    /**
     *
     * @ORM\Column(type="boolean")
     */
    protected $enabled;
    
    public function __toString()
    {
        return $this->name;
    }
}
