<?php

namespace Lizeo\PCPBundle\Entity;

use Lizeo\PCPBundle\Model\ErrorCode as AbstractTypeFile;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity()
 * @ORM\Table(name="sy_error_code")
 * @UniqueEntity("code")
 */
class ErrorCode extends AbstractTypeFile
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $name;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $description;
    
    /**
     *
     * @ORM\Column(type="integer", columnDefinition="TINYINT(1) NOT NULL")
     */
    protected $code;
    
    /**
     *
     * @ORM\Column(type="integer", columnDefinition="TINYINT(1) NOT NULL")
     */
    protected $level;
    
    public function __toString()
    {
        return $this->description;
    }
}
