<?php

namespace Lizeo\PCPBundle\Entity;

use Lizeo\PCPBundle\Model\Mail as AbstractMail;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity()
 * @ORM\Table(name="sy_mail")
 */
class Mail extends AbstractMail
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;
    
    /**
     *
     * @ORM\Column(type="datetime")
     */
    protected $send_date;
    
    /**
     *
     * @ORM\Column(type="integer", columnDefinition="TINYINT(1) NOT NULL")
     */
    protected $type;
    
    /**
     * @ORM\ManyToOne(targetEntity="File") 
     */
    protected $file;
    
    /**
     * @ORM\ManyToOne(targetEntity="Lizeo\UserBundle\Entity\User") 
     */
    protected $user;
    
    /**
     *
     * @ORM\Column(type="integer", columnDefinition="TINYINT(1) NOT NULL")
     */
    protected $status;
    
    public function __construct($type, $user, $file, $status)
    {
        $this->send_date = new \DateTime();
        $this->type = $type;
        $this->user = $user;
        $this->file = $file;
        $this->status = $status;
    }
}
