<?php

namespace Lizeo\PCPBundle\Entity\Repository;

use Doctrine\ORM\EntityRepository;

class ErrorCodeRepository extends EntityRepository
{
    public function findByLevel($levels)
    {
        $qb = $this->createQueryBuilder('e');
        
        if (is_array($levels)) {
            $qb->where($qb->expr()->in('e.level', $levels));
        } else {
            $qb->where('e.level = :level')
                    ->setParameter('level', $levels);
        }
        
        try {
            return $qb->getQuery()->getResult();
        } catch(\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
}
