<?php

namespace Lizeo\PCPBundle\Entity\Repository;

use Doctrine\ORM\EntityRepository;

class TypeFileDeadlineRepository extends EntityRepository
{
    /**
     * 
     * @return null 
     */
    public function findByDeadline($day)
    {
        $qb = $this->createQueryBuilder('d')
                ->where('d.date_deadline >= CURRENT_DATE()')
                ->andWhere("DATE_SUB(d.date_deadline, :day, 'day') <= CURRENT_DATE()")
                ->setParameter('day', $day);
        
        try {
            return $qb->getQuery()->getResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        }
    }
}
