<?php

namespace Lizeo\PCPBundle\Entity;

use Lizeo\PCPBundle\Model\TypeFile as AbstractTypeFile;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="Lizeo\PCPBundle\Entity\Repository\TypeFileRepository")
 * @ORM\Table(name="sy_type_file")
 * @UniqueEntity("tag")
 */

class TypeFile extends AbstractTypeFile
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $name;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $tag;
    /**
     *
     * @ORM\Column(type="integer")
     */
    protected $day_deadline;
    
    /**
     * @ORM\ManyToMany(targetEntity="Lizeo\UserBundle\Entity\Group", inversedBy="types_file")
     * @ORM\JoinTable(name="sy_type_file_group",
     *      joinColumns={@ORM\JoinColumn(name="type_file_id", referencedColumnName="id")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="group_id", referencedColumnName="id")}
     * )
     */
    protected $groups;
    
    /**
     *
     * @ORM\Column(type="boolean")
     */
    protected $enabled;
    
    /**
     *
     * @ORM\Column(type="boolean")
     */
    protected $convert_to_csv;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $csv_tab;
    
    
    /**
     *
     * @ORM\Column(type="integer")
     */
    protected $position;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $log_table;
    
    /**
     * @ORM\ManyToOne(targetEntity="Lizeo\PCPBundle\Entity\TypeFilePeriod") 
     */
    protected $type_period;
    
    /**
     *
     * @ORM\Column(type="string")
     */
    protected $job_talend;
    
    /**
     *
     * @ORM\Column(type="string", length="10")
     */
    protected $product_line;

    /**
     * Gets the groups granted to the user.
     *
     * @return Collection
     */
    public function getGroups()
    {
        return $this->groups ?: $this->groups = new ArrayCollection();
    }
    
    public function __toString()
    {
        return $this->name;
    }
    
    /**
     * Get csv tab in array 
     */
    public function getCSVTabArray()
    {
        return explode(',', $this->csv_tab);
    }
    
    public function setTypePeriod($type_period)
    {
        $this->type_period = $type_period;
        
        return $this;
    }
    
    public function getTypePeriod()
    {
        return $this->type_period;
    }
}
