<?php

namespace Lizeo\PCPBundle\EventListener;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpKernel\Event\FilterControllerEvent;
use Symfony\Component\HttpFoundation\Cookie;
use Symfony\Component\HttpFoundation\Response;
use Lizeo\UserBundle\Entity\User;

class CookieListener
{   
    public function onKernelController(FilterControllerEvent $event)
    {
        $controller = $event->getController();
        
        if(!is_array($controller) || !($controller[0] instanceof Controller))
        {
            return;
        }
        
        $user = $controller[0]->get('security.context')->getToken()->getUser();

        if($user instanceof User)
        {
            $cookie = new Cookie('USERNAME', $user->getUsername());
            $response = new Response();
            $response->headers->clearCookie('USERNAME');
            $response->headers->setCookie($cookie);
            $response->send();
        }
    }
}