<?php

namespace Lizeo\PCPBundle\Model;

abstract class Country
{
    
    protected $id;
    
    /**
     * @var string
     */
    protected $name;
    
    /**
     *
     * @var string 
     */
    protected $code;
    
    /**
     * @var boolean
     */
    protected $is_all;
    
    /**
     * @var integer 
     */
    protected $country_id;
    
    /**
     * @var boolean
     */
    protected $enabled;

    public function __construct($name = "", $enabled = true)
    {
        $this->name = $name;
        $this->enabled = $enabled;
    }

    public function getId()
    {
        return $this->id;
    }

    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     * @return Country
     */
    public function setName($name)
    {
        $this->name = $name;
        
        return $this;
    }
    
    public function getCode()
    {
        return $this->code;
    }
    
    public function setCode($code)
    {
        $this->code = $code;
    }
    
    /**
     * Checks whether the country is enabled.
     *
     * @return Boolean true if the country is enabled, false otherwise
     */
    public function isEnabled()
    {
        return $this->enabled;
    }

    /**
     * @param Boolean $boolean
     * @return Country
     */
    public function setEnabled($boolean)
    {
        $this->enabled = (Boolean) $boolean;
        
        return $this;
    }
    
    public function isIsAll()
    {
        return $this->is_all;
    }
    
    public function setIsAll($boolean)
    {
        $this->is_all = (Boolean) $boolean;
        
        return $this;
    }
    
    public function setCountryId($country_id)
    {
        $this->country_id = $country_id;
        
        return $this;
    }
    
    public function getCountryId()
    {
        return $this->country_id;
    }
}
