<?php

namespace Lizeo\PCPBundle\Model;

abstract class File
{
    CONST STATUS_AWAITING = 0;
    CONST STATUS_IN_PROGESS = 1;
    CONST STATUS_SUCCEED = 2;
    CONST STATUS_FAILED = 3;
    
    protected $id;
    
    /**
     * @var string
     */
    protected $name;
    
    /**
     * @var string 
     */
    protected $url;
    
    /**
     *
     * @var double 
     */
    protected $size;
    
    /**
     *
     * @var \DateTime 
     */
    protected $date_period;
    
    /**
     * @var \DateTime
     */
    protected $date_upload;
    
    /**
     *
     * @var Boolean 
     */
    protected $used;
    
    /**
     *
     * @var Boolean 
     */
    protected $valid;
    
    /**
     *
     * @var Boolean 
     */
    protected $reload;
    
    /**
     * @var string 
     */
    protected $gearman_id;
    
    /**
     *
     * @var int 
     */
    protected $gearman_return_code;
    
    /**
     *
     * @var int 
     */
    protected $status;

    public function __construct()
    {
        $this->date_upload = new \DateTime();
        $this->date_period = new \DateTime();
        $this->used = false;
        $this->valid = false;
        $this->reload = false;
        $this->status = self::STATUS_AWAITING;
    }

    public function getId()
    {
        return $this->id;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getDateUpload()
    {
        return $this->date_upload;
    }
    
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }
    
    public function getSize()
    {
        return $this->size / 1000;
    }
    
    public function setSize($size)
    {
        $this->size = $size;
    }
    
    public function isUsed()
    {
        return $this->used;
    }
    
    public function setUsed($boolean)
    {
        $this->used = (Boolean) $boolean;
        
        return $this;
    }
    
    public function isValid()
    {
        return $this->valid;
    }
    
    public function setValid($boolean)
    {
        $this->valid = (Boolean) $boolean;
        
        return $this;
    }
    
    public function getDatePeriod()
    {
        return $this->date_period;
    }
    
    public function setDatePeriod($date)
    {
        $this->date_period = $date;
        
        return $this;
    }
    
    public function setGearmanId($gearman_id)
    {
        $this->gearman_id = $gearman_id;
        
        return $this;
    }
    
    public function getGearmanId()
    {
        return $this->gearman_id;
    }
    
    public function setGearmanReturnCode($gearman_return_code)
    {
        $this->gearman_return_code = $gearman_return_code;
        
        return $this;
    }
    
    public function getGearmanReturnCode()
    {
        return $this->gearman_return_code;
    }
    
    public function setStatus($status)
    {
        $this->status = $status;
        
        return $this;
    }
    
    public function getStatus()
    {
        return $this->status;
    }
    
    public function setReload($reload)
    {
        $this->reload = $reload;
        
        return $this;
    }
    
    public function isReload()
    {
        return $this->reload;
    }
}
