<?php

namespace Lizeo\PCPBundle\Model;

abstract class TypeFilePeriod
{
    protected $id;
    
    /**
     * @var string
     */
    protected $name;
    
    /**
     *
     * @var string 
     */
    protected $months;
    
    /**
     * @var boolean
     */
    protected $enabled;

    public function __construct($name = "", $enabled = true)
    {
        $this->name = $name;
        $this->enabled = $enabled;
    }

    public function getId()
    {
        return $this->id;
    }

    public function getName()
    {
        return $this->name;
    }
    
    /**
     * @param string $name
     * @return TypeFile
     */
    public function setName($name)
    {
        $this->name = $name;
        
        return $this;
    }
    
    public function getMonths()
    {
        return $this->months;
    }
    
    public function setMonths($months)
    {
        $this->months = $months;
        
        return $this;
    }
    
    /**
     * Checks whether the type file is enabled.
     *
     * @return Boolean true if the type file is enabled, false otherwise
     */
    public function isEnabled()
    {
        return $this->enabled;
    }

    /**
     * @param Boolean $boolean
     * @return TypeFile
     */
    public function setEnabled($boolean)
    {
        $this->enabled = (Boolean) $boolean;
        
        return $this;
    }
}
