<?php

namespace Lizeo\PCPBundle\Service;

use Symfony\Component\DependencyInjection\ContainerInterface;

class Curl extends Service
{
    /**
     * Get last reporting reload start date and hour
     * @return date (YYY-MM-DD H:i:s) or false
     */
    public function getReportingReload()
    {
        $this->getLogger()->info('Starting to get reload file');
        $ftp_username = $this->getParameter('qlikview_ftp_username');
        $ftp_password = $this->getParameter('qlikview_ftp_password');
        $ftp_cert_path = $this->container->getParameter('qlikview_ftp_cert_path');
        $url = $this->getParameter('qlikview_reload_file');
        $tmp_file = $this->getParameter('tmp_dir') . 'curl_tmp_' . uniqid();


        /** @var \Lizeo\PCPBundle\Service\SshConnector $sshConnector */
        $sshConnector = $this->container->get('pcp_ssh_connector');
        $sshConnector->initSession();
        $isSent = $sshConnector->getFileByScp($url, $tmp_file);
        $sshConnector->closeSession();

        if ($isSent) {
            $line = $this->readLastLine($tmp_file);
            $line = explode('-', $line);
            $result = substr($line[1], 6, 4) . '-' . substr($line[1], 3, 2) . '-' . substr($line[1], 0, 2) . ' ' . substr($line[1], 11);
        } else {
            $this->getLogger()->alert('Error during file sending over SSH : ' . $url);

            $result = false;
        }

        unlink($tmp_file);

        return $result;
    }

    private function readLastLine($file)
    {
        $fp = fopen($file, "r");
        $pos = -1;
        $t = " ";

        while ($t != "\n") {
            if (!fseek($fp, $pos, SEEK_END)) {
                $t = fgetc($fp);
                $pos = $pos - 1;

                if ($pos == -2 && $t == "\n") {
                    $t = " ";
                }
            } else {
                rewind($fp);

                break;
            }
        }

        $t = fgets($fp);
        fclose($fp);

        return $t;
    }
}
