<?php


namespace Lizeo\PCPBundle\Utils;

/**
 * Manipulate file (read and write)
 * @author  Yenkong LYBLIAMAY
 * @version 2012-05-15 
 */
class FileManipulation
{
    
    private $fp = null;
    private $log_time;
    private $path;
    private $mode;
    private $secure;
    
    public function __construct($path, $mode, $log_time = true, $secure = false)
    {
        $this->log_time = $log_time;
        $this->path = $path;
        $this->mode = $mode;
        $this->secure = $secure;
        $this->open();
    }
    
    public function open()
    {
        $this->fp = fopen($this->path, $this->mode);
        
        if (!$this->fp) {
            $this->fp = null;
            throw new \Exception("Please check directory permission");
        }
    }

    public function write($message)
    {
        if (is_null($this->fp)) {
            throw new \Exception("Please initiate this ressource");
        }
        
        if ($this->log_time) {
            $message = date("[Y-m-d H:i:s] ").$message;
        }
        
        fwrite($this->fp, $message."\n");
        
        if ($this->secure) {
            $this->close();
            $this->open();
        }
    }
    
    public function read()
    {
        if (is_null($this->fp)) {
            throw new \Exception("Please initiate this ressource");
        }
        
        return fread($this->fp);
    }
    
    public function putcsv($fields, $delimiter = ";")
    {
        if (is_null($this->fp)) {
            throw new \Exception("Please initiate this ressource");
        }
        
        fputcsv($this->fp, $fields, $delimiter);
    }
    
    public function close()
    {
        if (is_null($this->fp)) {
            throw new \Exception("Please initiate this ressource");
        }
        
        fclose($this->fp);
    }
    
    public function getRessource()
    {
        return $this->fp;
    }
    
    public function setSecure($value)
    {
        $this->secure = $value;
    }
    
    public function isSecure()
    {
        return $this->secure;
    }
}
