<?php

namespace Lizeo\UserBundle\Entity;

use FOS\UserBundle\Entity\Group as BaseGroup;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="Lizeo\UserBundle\Entity\Repository\GroupRepository")
 * @ORM\Table(name="sy_fos_group")
 */
class Group extends BaseGroup
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;
    
    /**
     * @ORM\ManyToOne(targetEntity="Lizeo\PCPBundle\Entity\Country") 
     */
    protected $country;
    
    /**
     *
     * @ORM\Column(type="integer")
     */
    protected $position;
    
    /**
     * @ORM\ManyToMany(targetEntity="Lizeo\PCPBundle\Entity\TypeFile", mappedBy="groups")
     * @ORM\JoinTable(name="sy_type_file_group",
     *      joinColumns={@ORM\JoinColumn(name="group_id", referencedColumnName="id")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="type_file_id", referencedColumnName="id")}
     * )
     */
    protected $types_file;
    
    /**
     * @ORM\ManyToMany(targetEntity="User", mappedBy="group")
     **/
    protected $users;
    
    /**
     *
     * @ORM\Column(type="string", length="10")
     */
    protected $product_line;

    public function __construct()
    {
        $this->users = new ArrayCollection();
        $this->product_line = \Lizeo\PCPBundle\Model\ProductLine::PRODUCT_LINE_ALL;
        parent::__construct("");
    }
    
    /**
     * Gets the types file bounds to the user.
     *
     * @return Collection
     */
    public function getTypesFile()
    {
        return $this->types_file ?: $this->types_file = new ArrayCollection();
    }

    /**
     * Gets the coutries linked to the user.
     *
     * @return Collection
     */
    public function getCountry()
    {
        return $this->country;
    }
    
    public function setCountry($country)
    {
        $this->country = $country;
        return $this;
    }
    
    public function __toString()
    {
        return $this->name;
    }
    
    public function getPosition()
    {
        return $this->position;
    }
    
    public function setPosition($position)
    {
        $this->position = $position;
        return $this;
    }
    
    public function getProductLine()
    {
        return $this->product_line;
    }
    
    public function setProductLine($product_line)
    {
        $this->product_line = $product_line;
        return $this;
    }
    
    public function getUsers()
    {
        return $this->users;
    }
}
