<?php

namespace Lizeo\UserBundle\Entity\Repository;

use Doctrine\ORM\EntityRepository;

class UserRepository extends EntityRepository
{
    public function findByGroup($group_id)
    {
        $query = $this->createQueryBuilder('u')
                ->innerJoin('u.group', 'g')
                ->where('u.enabled = 1')
                ->andWhere('g.id = :group_id')
                ->setParameter('group_id', $group_id)
                ->getQuery();
        
        try {
            return $query->getResult();
        } catch (\Doctrine\ORM\NoResultException $e) {
            return null;
        } 
    }
}
