<?php

namespace Lizeo\UserBundle\Entity;

use FOS\UserBundle\Entity\User as BaseUser;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="Lizeo\UserBundle\Entity\Repository\UserRepository")
 * @ORM\Table(name="sy_fos_user")
 */
class User extends BaseUser
{
    public static $LIST_ROLE = array('ROLE_ADMIN' => 'ROLE_ADMIN', 'ROLE_CENTRAL' => 'ROLE_CENTRAL', 'ROLE_PAYS' => 'ROLE_PAYS', 'ROLE_MANAGER' => 'ROLE_MANAGER');
    const ROLE_CENTRAL = 'ROLE_CENTRAL';
    const ROLE_PAYS = 'ROLE_PAYS';
    const ROLE_MANAGER = 'ROLE_MANAGER';
    const ROLE_ADMIN = 'ROLE_ADMIN';
    
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;
    
    /**
     * @ORM\ManyToMany(targetEntity="Lizeo\UserBundle\Entity\Group")
     * @ORM\JoinTable(name="sy_fos_user_user_group",
     *      joinColumns={@ORM\JoinColumn(name="user_id", referencedColumnName="id")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="group_id", referencedColumnName="id")}
     * )
     */
    protected $group;
    
    /**
     * @ORM\OneToMany(targetEntity="Lizeo\PCPBundle\Entity\File", mappedBy="user") 
     */
    protected $files;
    
    /**
     * @ORM\OneToMany(targetEntity="Lizeo\PCPBundle\Entity\DownloadFile", mappedBy="user") 
     */
    protected $download_files;

    public function __construct()
    {
        parent::__construct();
    }
    
    public function setGroup($group)
    {
        $this->group = $group;
    }
    
    public function getGroup()
    {
        return $this->group;
    }
    
    public function getDownloadFiles()
    {
        return $this->download_files;
    }
    
    public function getGroups()
    {
        return $this->group ?: $this->group = new ArrayCollection();
    }
}
