<?php

namespace Lizeo\UserBundle\Security;

use FOS\UserBundle\Model\UserManagerInterface;
use FOS\UserBundle\Model\UserInterface;
use Symfony\Component\Security\Http\Event\InteractiveLoginEvent;
use Symfony\Component\HttpFoundation\Cookie;
use Symfony\Component\HttpFoundation\Response;

class InteractiveLoginListener
{
    protected $userManager;

    public function __construct(UserManagerInterface $userManager)
    {
        $this->userManager = $userManager;
    }

    public function onSecurityInteractiveLogin(InteractiveLoginEvent $event)
    {
        $user = $event->getAuthenticationToken()->getUser();

        if ($user instanceof UserInterface) {
            $cookie = new Cookie('USERNAME', $user->getUsername());
            $response = new Response();
            $response->headers->clearCookie('Login');
            $response->headers->clearCookie('USERNAME');
            $response->headers->clearCookie('AccessPointSession');
            $response->headers->setCookie($cookie);
            $response->send();
        }
    }
}
